include lib
;-----------------------------------------------------------------------------
;COPY
;-----------------------------------------------------------------------------
;COPY kopiert eine oder mehere Dateien. Es besteht auch die Mglich beim 
;Kopiervorgang Dateien umzubenennen. Verzeichnisse knnen nicht kopiert werden.
;Beim Kopiervorgang wird darauf geachtet, da niemals zwei Dateien im gleichen
;Verzeichnis den selben Namen haben.
copy:           push       #cwd                 ;CWD suchen
		sys        #10
		inc        sp
		move mi    #111,d0              ;Es existiert keine CWD
		jmi        .fehler              ;... deshalb Fehler
		move       d0,d5        	;cwd_zeiger: Zeiger auf cwd
		move       d0,d6       		;gleiches gilt fr cwd_zeiger2
		push       #cmd
		sys        #10                  ;CmdLine suchen
		inc        sp
		move       d0,CmdLine           ;CmdLine: Zeiger auf String
		cmp        (CmdLine),-          ;Ist kein Parameter angegeben?
		move eq    #111,d0              ;Nein, Parameter fehler
		jeq        .fehler

;Verschiedene Pufferbereiche einstellen
		move       #quellpuffer,quellpfad	;Quell_pfad wird auf den Anfang eines Directory-Pfades zeigen
		move       #zielpuffer,zielpfad		;zielpfad wird auf den Anfang der kopierten Datei zeigen  

;Quelleverzeichnis bestimmen
		cmp        (CmdLine),#$2f	;Ist Pfad mit angegeben?
		jeq        .explizit            ;ja,
.cwd:           cmp        (d5),-               ;Nein, Cwd in den Quellpfad kopieren
		move ne    (d5),(quellpfad)
		inc  ne    d5
		inc  ne    quellpfad
		jne        .cwd

.explizit:      cmp        (CmdLine),-                  ;Angegeben Namen an Quellpfad anschlieen
		move eq    #111,d0
		jeq        .fehler
		cmp        (CmdLine),#32                ;" "=Abbruch, an gegebenen Pfad kopieren
		clr  eq    (CmdLine)                    ;Trenzeichen in Suchstring erzeugen
		move eq    CmdLine,CmdPos               ;Position des Trennzeichens merken fr Restauration der CmdLine
		move ne    (CmdLine),(quellpfad)
		inc        CmdLine                      ;In CmdLine auf zweiten Parameter weiterschalten
		inc  ne    quellpfad
		jne        .explizit            

;Vom Pfad den Suchstring isolieren und den Pfad des entsprechendes
;Verzeichnisses isolieren
		move       CmdLine,such_strg
.cut:           cmp        (quellpfad),#$2f             ;letzten Teil lschen
		clr        (quellpfad)
		dec ne     quellpfad                    ;quellpfad:letzte Position der Quelle
		dec ne     such_strg
		jne        .cut

;Ziel bestimmen
.ziel:          cmp        (CmdLine),#$2f               ;Ist Pfad mit angegeben?
		jeq        .zexplizit                   ;ja...
		cmp        (CmdLine),#$2e               ;Ist aktuelles Verzeichnis gemeint?
		jne        .zcwd                        ;nein...
		inc        CmdLine
		cmp        (CmdLine),-
		dec ne     CmdLine

;CWD fr Zielpfad kopieren
.zcwd:          cmp        (d6),-
		move ne    (d6),(zielpfad)     ;Cwd kopieren
		inc  ne    d6
		inc  ne    zielpfad
		jne        .zcwd

;Angegebenes Pfadstck an Quellpfad anschlieen
.zexplizit:     move    sf (CmdLine),(zielpfad)
		inc  ne    CmdLine
		inc  ne    zielpfad
		jne        .zexplizit           

;Soll auch der Name gendert werden?
		dec        zielpfad
		cmp        (zielpfad),#$2f	;Endet der Pfad mit /?
		inc  eq    zielpfad 		;Falls ja, soll der Name nicht gendert werden
		move eq    #$2a,new_name
		add  eq    -,#new_name,d0
		clr  eq    (d0)
		jeq        .open
			
;Neuen Namen isolieren und nach new_name kopieren
.zcut:          cmp        (zielpfad),#$2f	;letzten Teil des Zielpfades lschen
		clr ne     (zielpfad)
		dec ne     zielpfad
		dec ne     CmdLine
		jne        .zcut
		inc        zielpfad
		move	   #new_name,d0
.namecopy:	move	sf (CmdLine),(d0)
		inc 	   CmdLine
		inc 	   d0
		jne	   .namecopy

;Quellverzeichnis ffnen
.open:          push       -                            ;zum Lesen ffnen
		push       #quellpuffer
		sys        #12                          ;OPEN,Quellverzeichnis
		add        #2,sp
		jmi        .restauriert
		move       d0,quell_dir                 ;quell_dir: FDB-Adresse

		move       #$2f,(quellpfad)             ;Ein "/" an Quellpfad anhngen
		inc        quellpfad

;Suchstring vorbereiten mit PREPARE_SEARCH
		push       quell_dir                    ;FDB-Adresse
		push       #such_strg_puffer		;Pufferadresse
		push       such_strg                    ;Zeiger auf Namen
		sys        #26                          ;Suchstring vorbereiten
		add        #3,sp
.restauriert:   move       #32,(CmdPos)                 ;CmdLine restaurieren           
		jmi        .fehler

;Zu kopierende Dateien suchen
.searchread:    add        #8,#lesepuffer,d7    ;Zeiger auf Dateinamen

;Abbruchkommando  (CTRL-C) berprfen
		push       -                    ;EinZeichen von StIn lesen
		dec        sp
		pushz
		sys        #13                  ;READ
		add        #3,sp
		and     sf #$ff,d0              ;Nur ASCII-Code betrachten 
		cmp        d0,#3                ;CTRL-C?
		jeq        .abbruch             ;Ja, Befehl abbrechen

;Nchsten passenden Eintrag suchen
		push       #such_strg_puffer	;Zeiger auf Suchstring
		push       quell_dir 		;FDB-Adresse
		sys        #27 			;SEARCH_NEXT
		add        #2,sp
		jpl	   .ok			;Alles ok
		cmp	   d0,#105		;EOF?
		jeq        .ende
		jmp	   .fehler

;Verzeichniseintrag lesen
.ok:		push       #16                          ;16 Wrter
		push       #lesepuffer
		push       quell_dir                    ;FDB-Adresse
		sys        #13                          ;READ
		add        #3,sp
		jmi        .fehler

;Dateinamen an Quell- und Zielpfad anhngegen, gegebenenfalls Zielnamen verndern
		move       #8,d2                   ;Zhler
		move       quellpfad,d1
		move       zielpfad,d0
		move       #new_name,d3
.copy:          bswp       (d7),-,(d1)          ;High-Byte kopieren
		bswp       (d7),-,(d0)
		cmp        (d3),#$3f		;Bei ? Namen nicht verndern
		inc eq     d3
		jeq        .next
		cmp        (d3),#$2a		;Bei * Namen nicht verndern
		jeq        .next
		move       (d3),(d0)
		inc        d3
.next:          inc        d1
		inc        d0
		and        #$ff,(d7),(d1)       ;Low-Byte kopieren
		and        #$ff,(d7),(d0)
		cmp        (d3),#$3f		;Bei ? Namen nicht verndern
		inc eq     d3
		jeq        .next2
		cmp        (d3),#$2a                  ;Bei * Namen nicht verndern
		jeq        .next2
		move       (d3),(d0)
		inc        d3
.next2:         inc        d1
		inc        d0
		inc        d7
		dec     sf d2                           ;Schon 16 Bytes kopiert?
		jne        .copy                        ;Nein, wiederholen
		clr        (d1)                         ;Stringendezeichen anfgen
		clr        (d0)                         ;Stringendezeichen anfgen

;Quellnamen ausgeben
		move       #quellpuffer,d0
		jsr        .stringout
		jmi        .fehler              

;Quelle zum Lesen ffnen
		push       -
		push       #quellpuffer
		sys        #12                  ;Quelle ffnen
		add        #2,sp                
		jmi        .fehler
		move       d0,quell_fdb

;D(irectory)-Flag berpfrfen
		add        #15,d0               ;Directories knnen nicht kopiert werden
		and     sf -,(d0),-             ;Dir?
		move ne    #111,d0
		jne        .dir                 ;Ja Fehlermeldung ausgeben

;Ziel zum Neuschreiben ffnen
		push       #3                   ;zum Neuschreiben ffnen
		push       #zielpuffer          
		sys        #12                  ;Ziel ffnen
		add        #2,sp                
		jpl        .go_on               ;Falls kein Fehler weiter bei go_on

		cmp        d0,#110              ;Existiert der Dateiname schon?
		jne        .fehler              ;Nein anderer Fehler

;Fehlermeldung, da Datei schon existiert ausgeben
		move       #exist_schon,d0
		jsr        .stringout           ;Stringausgeben
		jmi        .fehler              
		jmp        .close2              ;Quelldatei wieder schlieen

;Aus Quelldatei lesen
.go_on:         move       d0,ziel_fdb
		move       -,d4			;Eof auf False
.copy3:         push       #2048		;Block einlesen
		push       #kopierpuffer
		push       quell_fdb
		sys        #13                  ;READ                   
		add        #3,sp
		jpl        .write
		cmp        d0,#105              ;EOF-Fehler?
		jne        .spezialfehler       ;Nein, Spezialbehandlung
		clr        d4

;An Zieldatei Anzahl der gelesenen Worte schreiben
.write:         cmp        d1,-                 ;Lnge gleich Null?
		jeq        .test                ;ja, nichts schreiben
		push       d1                   ;Blockablegen
		cmp        -,d1                 ;Lnge gleich Eins?
		push ne    #kopierpuffer      	;Nein,Adresse bergeben
		push eq    kopierpuffer		;Ja, Zeichen bergeben
		push       ziel_fdb
		sys        #14                  ;WRITE
		add        #3,sp
		jmi        .fehler
.test:          cmp        d4,-
		jne        .copy3

;Dateiflags auch kopieren
		push       quell_fdb
		sys        #16                  ;GET-FLAGS
		
		push       d0
		push       ziel_fdb
		sys        #17                  ;SET-FLAGS
		add        #3,sp
		jmi	   .fehler

;" kopiert nach " ausgeben
		move       #nach,d0
		jsr        .stringout
		jmi        .fehler              

;kompletten Zielnamen ausgeben
		move       #zielpuffer,d0
		jsr        .stringout
		jmi        .fehler              

;Linefeed ausgeben
		move       #lf,d0
		jsr        .stringout
		jmi        .fehler              

;die geffneten Dateien wieder schlieen
.close:         push       ziel_fdb
		sys        #15                  ;CLOSE, Ziel schlieen
		inc        sp
.close2:        push       quell_fdb
		sys        #15                  ;CLOSE, Quelle schlieen
		inc        sp
		jmp        .searchread          ;Nchsten zu kopierende Datei suchen

;Fehlerstring bei Directory ausgeben
.dir:           move       #dir_fehler,d0
		jsr        .stringout
		jmi        .fehler              
		jmp        .close               

;Bei anderem Fehler als EOF wird die zum Teil kopierte Datei wieder gelscht,
;da sie noch unvollstndig ist.
.spezialfehler: move       d0,d3
		push       ziel_fdb 
		sys        #21                  ;Gefundene Datei lschen
		inc        sp
		move       d3,d0

.fehler:        push       d0
		sys        #29                  ;Fehlerstringausgabe
		inc        sp

;Quellverzeichnis und Dateien schlieen
.ende:          push       quell_dir
		sys        #15                  ;Quellverzeichnis schlieen
		push       quell_fdb
		sys        #15                  ;Quelldatei schlieen
		push       ziel_fdb
		sys        #15                  ;Zieldatei schlieen
		add        #3,sp
		rts

;String bei Befehlsunterbrechung ausgeben
.abbruch:       move       #break,d0
		jsr        .stringout
		jmp        .ende                

;String ausgeben
.stringout:     pushz                           ;String ausgeben
		push       d0
		pushz                           ;an StandardOut
		sys        #14                  ;WRITE
		add        #3,sp
		rts



cmd:                    dw "cmd="
cwd:                    dw "cwd="
quell_dir:              dw 0    ;FDB-Adresse des Quellverzeichnisses
quell_fdb:              dw 0    ;FDB-Adresse der Quelldatei
ziel_fdb:               dw 0    ;FDB-Adresse der Zieldatei
such_strg:              dw 0    ;Zeiger auf den Suchstring
lf:                     dw 13,10,0      ;Linefeed
nach:                   dw " kopiert nach ",0
dir_fehler:             dw " ist Verzeichnis und kann nicht kopiert werden!",13,10,0
exist_schon:            dw " existiert schon!",13,10,0
break:                  dw 13,10,"Befehlsunterbrechung.",13,10,0

data
quellpuffer: 256	;Puffer fr Quelldateipfad
quellpfad: 1		;Zeiger aif ein Zeichen nach dem Quellpfad, dort mu der Dateinamen angehngt werden
zielpuffer: 256		;Puffer fr Zieldateipfad
zielpfad: 1		;Zeiger auf den Pufferbereich, der den Zielpfad enthlt (256 Worte)
kopierpuffer: 2048	;Kopierpuffer fr 4 Sektoren
lesepuffer: 16		;Lesepuffer fr Verzeichniseintrag 
new_name: 16 		;Neuer Name bei Namensnderung
such_strg_puffer: 8	;Suchstring (komprimierter Name fr Search-Next)
CmdLine: 1		;Zeiger auf Parameter in der CmdLine
CmdPos: 1		;Zeiger fr Position des gelschten Space in der CmdLine
stack: 128		;Stackbereich
