include lib
;-----------------------------------------------------------------------------
;DISKINFO
;-----------------------------------------------------------------------------
;DISKINFO gibt den Datentrgernamen, die Speicherkapazitt und die Anzahl der
;freien Worte des Datentrgers aus
diskinfo:	push	   #cmd
		sys	   #10			;CmdLine suchen
		inc	   sp
		cmp	   (d0),-		;Falls CmdLine leer -> Fehler
		move eq	   #111,d0
		jeq	   .fehler

;Treiberadresse bestimmen
		push       d0
		sys	   #8			;SEARCHDRIVER
		inc        sp
		jmi        .fehler
		move       d0,d5

;Handelt es sich auch um ein Blockdevice?
		dec	   d0
		and 	sf -,(d0),-		;Zeichendevice?
		move ne	   #111,d0
		jne	   .fehler

;Name des Datentrgers ermitteln
		push	   #8
		push	   #8
		pushz
		pushz	
		push	   #puffer
		push	   -
		driver	   d5
		add	   #6,sp
		jmi	   .fehler
		
;String ausgeben
		move	   #name,d0
		jsr	   .stringout
		jmi	   .fehler

;Datentrgernamen zeichenweise ausgeben
		move	   #puffer,d4
		move	   #8,d3
.nameloop:	bswp	sf (d4),-,d0		;High-Byte ausgeben
		jeq	   .cap
		jsr	   .out
		jmi	   .fehler

		and	sf #$ff,(d4),d0		;Low-Byte ausgeben
		jeq	   .cap
		jsr	   .out
		jmi	   .fehler
		
		inc	   d4
		dec	sf d3			;Schon 16 Bytes ausgegeben
		jne	   .nameloop
				
;Kapazitt ermitteln
.cap:		push	   #puffer
		push	   #3			;JOB 3:read capacity
		driver	   d5
		add	   #2,sp
		jmi	   .fehler
		
;Kapazittsstring ausgeben
		move	   #kap,d0		;"Worte auf Datentrger insgesamt: "
		jsr	   .stringout
		jmi	   .fehler

;Kapazitt umrechnen in Wortgre
		clr 	   d6
		add	   -,#puffer,d1		;Anzahl der Worte berechen
		add	sf -,(d1)		;Wegen SCSI Angabe mu noch ein Sektor hinzugefgt werden
		add	cs -,puffer
		bswp	   (d1),-,d0
		bswp	   -,(d1)
		bswp	   -,puffer
		add	   d0,puffer

;Wortanzahl High ausgeben
		move	   puffer,d2
		jsr 	   .zahlout
		jmi	   .fehler

;Wortanzahl Low ausgeben
		add	   -,#puffer,d0
		move	   (d0),d2
		jsr 	   .zahlout
		jmi	   .fehler

;Freispeicher ermitteln, dazu BAM durchsuchen
		push	   -			;Lnge der Bam einlesen
		push	   #17
		pushz
		pushz
		push	   #BAMlng
		push	   -
		driver	   d5
		add	   #6,sp
		jmi	   .fehler
		

;Bam Sektoren der Reihe nach einlesen und Anzahl der freien Sektoren ermitteln
.loop:		push	   #256			;BAM-Sektor einladen
		pushz
		push	   sektornr
		pushz
		push	   #puffer
		push	   -
		driver	   d5
		add	   #6,sp
		jmi	   .fehler

		move 	   #puffer,d0	
		move	   #256,d7

.add:		cmp	   (d0),#$ffff	;Wort voll belegt?
		jeq	   .next	;ja, weiter
		cmp	   (d0),-	;Wort ganz leer?
		jne	   .bits	;Nein, einzelne Bits auswerten	
		add  eq	sf #4096,low	;Ein freies Wort = 16 Bit *256 Worte =4096 Worte
		add  cs	   -,high
		jmp	   .next
		
.bits:		move	   -,d1
		move	   #16,d3
.bitloop:	and	sf d1,(d0),-
		add  eq sf #256,low	;Pro Bit gibt es 256 freis Worte auf dem Medium
		add  cs	   -,high
		asl	   d1
		dec	sf d3
		jne	   .bitloop
		
.next:		inc	   d0
		dec	sf d7		;Alle Worte des Sektors untersucht?
		jne	   .add		;Nein, weiter machen

		inc	   sektornr	;BAM-Sektornr inc.
		dec	sf BAMlng	;Existieren noch weiter BAM-Sektoren?
		jne	   .loop	;ja,...
		
;Freispeicherstring ausgeben
		move	   #freispeicher,d0
		jsr	   .stringout
		jmi	   .fehler

;Anzahl der freien Worte ausgeben
		clr	   d6		;Fhrende Nullen Flag auf TRUE
		move	   high,d2	;Worte high ausgeben
		jsr	   .zahlout
		jmi	   .fehler

		move	   low,d2	;Worte low ausgeben
		jsr	   .zahlout
		jmi	   .fehler

		move	   #lf,d0	;Linefeed ausgeben
		jsr	   .stringout
		jmi	   .fehler
		rts

;Zahl-Ausgabe-Routine 
.zahlout:	move	   #4,d3
.zahlloop:	rol	   d2
		rol	   d2
		rol	   d2
		rol	   d2
		and	   #$f,d2,d0
		cmp	   #10,d0	;Zahl odeer Buchstabe?
		add mi	   #$30,d0	;Zahl!
		add pl	   #55,d0	;Buchstabe!

		cmp	   d0,#$30	;Fhrende Null?
		move ne	   -,d6
		jne  	   .ausgeben	;Nein ausgeben

		cmp	   d6,-
		move eq	   #32,d0	;JA, Space ausgeben

.ausgeben:	jsr	   .out
		rts mi

		dec	sf d3
		jne	   .zahlloop
		rts

;Zeichenausgabe
.out:		push	   -		;Zeichen ausgeben
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		rts 

;String an StandardOut ausgeben
.stringout:	pushz
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		rts

.fehler:	push	   d0
		sys	   #29		;Fehlerausgabe
		inc	   sp
.ende:		rts


cmd:		dw "cmd="
high:		dw 0	;Auszugebende Lnge High
low:		dw 0	;Auszugebende Lnge Low
sektornr:	dw 1	;Sektornummer des aktuellen BAM-Sektors
lf:		dw 10,13,0
freispeicher:	dw 13,10,"Worte verfgbar: $",0
name:		dw "Medienname: ",0
kap:		dw 13,10,"Worte insgesamt: $",0

data
BAMlng: 1		;BAM-Lnge in Sektoren
puffer: 256+128		;Puffer und Stackbereich