include lib
;-----------------------------------------------------------------------------
;FORMAT
;-----------------------------------------------------------------------------
;FORMAT erstellt nur Rootdirectory und BAM, kein Low-Level-Format.
format:		move	   #warnung,d0	;Warnmeldung ausgeben
		jsr	   stringout
		jmi	   fehler
		
;Ein Zeichen einlesen, bei "j" oder "J" weiter, sonst Abbruch
.getloop:	push	   -		;Ein Zeichen einlesen, j=ok
		dec	   sp
		pushz
		sys	   #13		;READ
		add	   #3,sp
		jmi	   .getloop
		move	   d0,anzahl	;Anzahl wird mibraucht

;Zeichen wieder ausgeben
		push	   -
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmi	   fehler

;ASCII-Code berprfen
		and	   #$ff,anzahl	;Nur Zeichencode betrachten
		cmp	   anzahl,#$4a	;J?
		jeq	   .ok		;ja
		cmp	   anzahl,#$6a	;j?
		jne	   ende		;auch nicht!, ende

;CmdLine suchen
.ok:		push	   #cmd
		sys	   #10		;SEARCH_ENV
		inc	   sp

		move	   d0,CmdLine
		move       d0,device	;Zeiger auf Gertenamen

;Treibernamen isolieren
loop1:		cmp	   (CmdLine),-		;Falls CmdLine leer -> Fehler 
		move eq	   #111,d0
		jeq	   fehler
		cmp	   (CmdLine),#32	;Abbruch
		clr  eq	   (CmdLine)		;0 in Env-Variable erzeugen
		move eq	   CmdLine,CmdPos	;Position fr Restauration der CmdLine merken
		inc	   CmdLine
		jne	   loop1

;Treiberadresse bestimmen
		push       device
		sys	   #8		;SEARCHDRIVER
		inc        sp
		move	   #32,(CmdPos)	;CmdLine Restaurieren
		jmi        fehler
		move       d0,device
		dec	   d0

		and 	sf -,(d0),-	;Blockdevice?
		move ne	   #111,d0	;Nein, Fehler
		jne	   fehler

;Dateinamen berprfen
		add        #8,#puffer,d0	;Dateinamen kompremieren
		push       d0
		push       CmdLine
		sys	   #28			;SCAN, Dateiname berprfen
		add        #2,sp
		jmi        fehler

;read cpacity in Arbeitspuffer
		push       #puffer           
		push       #3          	;Job 3:read capacity
		driver     device   
		add        #2,sp
		jmi        fehler

;SCSI-Angabe gibt letzte Sektornummer an, deswegen mu fr die Anzahl der
;Sektoren noch eins hinzuaddiert werden
		add        -,#puffer,d1
		move       puffer,d0	;Kapazitaet hi
		add	sf -,(d1),d1	;Kapazitaet lo
		add cs	   -,d0		;Eins mehr wegen SCSI-Macke

;Lnge der BAM in Sektoren, Wortanzahl im letzten Sektor und Bitposition
;im letzten Wort bestimmen
		asl	   d0		;Kap-hi*16
		asl	   d0
		asl	   d0
		asl	   d0		;d0=Anzahl Sektoren bzgl. Kap hi
		add	   -,d0,sektoren
		bswp	   d1,-,d0
		asr	   d0
		asr	   d0
		asr	   d0
		asr	   d0
		add	   d0,sektoren	;sektoren=(Kaphi*16)+(Kaplow div 4096)+1
		and	   #15,d1,bit	;Bit=Bitposition im letzten BAM-Wort
		asr	   d1
		asr	   d1
		asr	   d1
		asr	   d1
		and	   #$ff,d1,worte ;d1=Anzahl der Worte im letzen Sektor

;Bootsektor erstellen
bootsektor:	move       #puffer,d1	;Zeiger auf Arbeistpeicher
		move	   #237,d0	;Ende des Sektorpuffers
		clr	   (d1)		;Primrsektor der Rootdir
		inc        d1
		clr	   (d1)
		inc        d1
		clr	   (d1)		;Lnge der Rootdir
		inc        d1
		clr	   (d1)
		inc        d1
		clr	   (d1)		;Schachtelungstiefe der Rootdir
		inc        d1
		move       -,(d1)	;D-Flag setzen
		inc        d1
		move       28,(d1)  	;Kennung, Timerh
		inc        d1
		move       29,(d1)  	;Kennung, Timerl
		add        #10,d1      	;Dateiname ist schon eingetragen, berspringen
;               move       random,(d1) 	;Prfwort
		move	   28,(d1)	;Hier timerl
		inc        d1
		move       sektoren,(d1)	;Laenge BAM in Sektoren
		inc	   d1
		move	   -,(d1)	;Beginn der Sektorsuche
clearboot:     	inc        d1		;Rest des Verwaltungssektor...
		clr        (d1)		;...lschen
		dec     sf d0
		jne        clearboot

;Puffer in Cache schreiben
		push       #256		;256 Worte 
		pushz			;Ab Position 0
		pushz			;Sektornummer lo
		pushz			;Sektornummer hi
		push       #puffer      ;Pufferadresse
		push       #2		;Job 2: Schreiben
		driver     device
		add        #6,sp
		jmi	   fehler

;1. BAM Sektor erstellen
		move       #puffer,d1			;Anfang des Puffers
		clr        d0				;Anzahl der Worte, die in der BAM belegt sind
		add        -,sektoren,sysbelegung	;BAM+BOOTSEKTOR
belegte_worte: 	sub     sf #16,sysbelegung
		move pl    #$ffff,(d1)  		;>16 belegt Sektoren
		inc  pl    d1
		jpl        belegte_worte

;Hinzu kommen <16 belegte Sektoren, d.h. Sektoren die kein ganzes BAM-Wort belegen
		add  mi    #16,sysbelegung
		clr        (d1)
		move       -,d0
belegt:        	dec    sf  sysbelegung
		or   pl    d0,(d1)
		asl  pl    d0
		jpl        belegt

;Rest des Sekotrs lschen 
		add        #puffer,#255,d0	;Ende des Pufferbereiches
loeschen:	inc        d1
		clr        (d1)
		cmp        d1,d0 
		jpe        loeschen

;Sektor speichern
		push       #256		;256 Worte 
		pushz			;Ab Position 0
		push       -		;Sektornummer lo
		pushz			;Sektornummer hi
		push       #puffer	;Pufferadresse
		push       #2		;Job 2: Schreiben
		driver     device
		add        #6,sp
		jmi	   fehler

;BAM-Sektoren, die ganz gegelscht werden
		cmp        -,sektoren	;Existiert nur ein BAM-Sektor?
		jeq        same		;Ja
		sub        #2,sektoren,anzahl
		move       #2,sektoren	;sektoren wird jetzt als Sektornummer benutzt, 2.ter BAM-Sektor

loop2:		dec     sf anzahl
		jmi        last    
		move       #puffer,d1
		move	   #256,d0	;Ende des Pufferbereiches

;Sektor ganz lschen
clearbam:	dec	sf d0
		clr pe     (d1)
		inc pe     d1
		jpe        clearbam

;Sektor abspeichern
		push       #256		;256 Worte 
		pushz			;Ab Position 0
		push       sektoren	;Sektornummer lo
		pushz			;Sektornummer hi
		push       #puffer	;Pufferadresse
		push       #2		;Job 2: Schreiben
		driver     device 
		add        #6,sp
		jmi	   fehler

		inc        sektoren
		jmp        loop2

;letzten BAM-Sektor erstellen, nicht existente Sektoren mssen als
;belegt gekennzeichnet werden
last:		move       #puffer,d1
		move	   worte,d0

;Bis zur Wortposition Sektor lschen
clearlast:	dec	sf d0
		clr pe     (d1)
		inc pe     d1
		jpe        clearlast

;letztes BAM-Wort erstellen
same:		add        #puffer,worte,d1	;Position des letzten BAM-Wortes
		move       #$ffff,(d1)		;letzten BAM-Sektor eintragen
belegt2:	dec     sf bit			;bit enthaelt die Anzahl der Bits im letzten BAM-Wort
		asl pl     (d1)
		jpe        belegt2

;Rest des Sektor mit $ffff fllen, als belegt kennzeichnen
		sub	   worte,#256,d0	;Ende des Puffers
fill:		dec	sf d0 
		inc  pe    d1
		move pe    #$ffff,(d1)
		jpe        fill

;Sektor abspeichern
		push       #256		;256 Worte 
		pushz			;Ab Position 0
		push       sektoren	;Sektornummer lo
		pushz			;Sektornummer hi
		push       #puffer	;Pufferadresse
		push       #2		;Job 2: Schreiben
		driver     device
		add        #6,sp
		jmi	   fehler

;Cache Flushen
		push	   #6		;Flush
		driver	   device
		inc	   sp
		jmi	   fehler
		clr     sf ~-           ;Flags lschen

;Erfolgsmeldung ausgeben
		move	   #meldung,d0		;Meldung ausgeben
		jsr	   stringout
		jmi	   fehler

ende:		move	   #lf,d0		;Linefeed ausgeben
		jsr	   stringout
  		rts                          

fehler:		push	   d0
		sys	   #29
		inc	   sp
		rts

;String an StandardOut ausgeben
stringout:	pushz
		push	   d0
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		rts


cmd:		dw "cmd="
CmdLine:	dw 0	;Zeiger auf CmdLine
CmdPos:		dw 0	;Enthlt Position der CmdLine, an der etwas verndert wurde
sysbelegung:	dw 0	;Enthlt Anzahl der von BAM und Bootsektor belegten  Sektoren
sektoren:	dw 0	;Anzahl der Sektoren der BAM
worte:		dw 0	;Wortpositon des letzten BAM-Wortes im letzten BAM-Sektor
bit:		dw 0	;Bitpositon des letzten BAM-Bits im letzten BAM-Wort
device:	 	dw 0	;TReiberadresse
anzahl:		dw 0	;Anzahl der zu lschenden BAM-Sektoren
lf:		dw 10,13,0
meldung:	dw 13,10,"High-Level-Format erzeugt.",0
warnung:	dw 10,13,"Alle Daten werden gelscht! Sind Sie sicher? (j/n) ",0
data
puffer:	256+128		;Puffer und Stackbereich