include lib
;-----------------------------------------------------------------------------
;TASKLST
;-----------------------------------------------------------------------------
;TASKL(i)ST zeigt alle im Tasks im System mit ihren Devices an.
tasklst:	move	   17,d5	;Adr. 17=akt_task

;Headline an StandardOut
		move	   #start,d0
		jsr	   .stringout
		jmi	   .fehler

;Tasks ausgeben
.loop:		add	   #12,d5,d2	;d2: Zeiger auf Taskname
		move	   #8,d4	;Acht Zeichen Taskname ausgeben

;Taskname zeichenweise ausgeben
.nameloop:	move	sf (d2),d0
		move eq	   #32,d0
		jsr	   .out
		jmi	   .fehler
		inc	   d2
		dec	sf d4
		jne	   .nameloop

;3 Spaces ausgeben
		move	   #space3,d0
		jsr	   .stringout
		jmi	   .fehler

;Tasknummer ausgeben
		sub	   -,d5,d3
		move	   (d3),d3
		move	   #4,d4
.zahlloop:	rol	   d3
		rol	   d3
		rol	   d3
		rol	   d3
		and	   #$f,d3,d0
		cmp	   #10,d0
		add mi	   #$30,d0
		add pl	   #55,d0
		jsr	   .out		;Tasknummer ausgeben
		jmi	   .fehler

		dec	sf d4
		jne	   .zahlloop

;Spaces ausgeben
		move	   #space,d0	
		jsr	   .stringout
		jmi	   .fehler

;StandardIn bestimmen und ausgeben
		add	   #20,d5,d2
		move	   (d2),d2
		cmp	   d2,-		;Null-Device
		add	   #2,d2		;Zeiger auf Treiberadresse
		sub	   #5,(d2),d2	;Zeiger auf Namen im Treiber
		move eq    #nul,d2
		move	   #4,d4

;Devicenamen ausgeben
.stinloop:	move	sf (d2),d0
		move eq	   #32,d0
		jsr	   .out
		jmi	   .fehler
		inc	   d2
		dec	sf d4
		jne	   .stinloop

;Spaces ausgeben
		move	   #space,d0	
		jsr	   .stringout
		jmi	   .fehler

;StandardOut bestimmen und ausgeben
.stout:		add	   #21,d5,d2
		move	   (d2),d2
		cmp	   d2,-
		add	   #2,d2
		sub	   #5,(d2),d2
		move eq    #nul,d2
		move	   #4,d4

;Devicenamen ausgeben
.stoutloop:	move	sf (d2),d0
		move eq	   #32,d0
		jsr	   .out
		jmi	   .fehler
		inc	   d2
		dec	sf d4
		jne	   .stoutloop

;Linefeed an StandardOut
		move	   #lf,d0
		jsr	   .stringout
		jmi	   .fehler

;Auf nchste Task weiterschalten
		add	   #11,d5
		move	   (d5),d5
		cmp	   d5,17
		jne	   .loop
		rts

;Zeichen ausgeben
.out:		push	   -
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		rts

;String ausgeben
.stringout:	pushz
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		rts

.fehler:	push	   d0
		sys	   #29		;Fehlerausgabe
		inc	   sp
.ende:		rts

lf:		dw 10,13,0
start:		dw 10,13,"Taskname   Handle   StdIn-Device StdOut-Device",13,10,
		dw "----------------------------------------------",13,10,0
nul:		dw "Null",0
space:		dw "          ",0
space3:		dw "   ",0
data
stack: 64				;Stackbereich