;=============================================================================
;LIBRARY
;=============================================================================
;Vereinbarungen
;.............................................................................
equ d0,8	;8 Arbeitsregister fr aktuelle Task
equ d1,9
equ d2,10
equ d3,11
equ d4,12
equ d5,13
equ d6,14
equ d7,15
equ sp,16	;Stackpointer fr aktuelle Task

equ akt_task,17
equ timerh,28
equ timerl,29

;Befehlsmakros
;Sprungbefehle
;.............................................................................
macro jmp 1
  add tr hf #%1,-,=
endm

macro bra 1
  add %c hf %1,-,=
endm

macro jne 1
  add ne hf #%1,-,=
endm

macro jeq 1
  add eq hf #%1,-,=
endm

macro jpl 1
  add pl hf #%1,-,=
endm

macro jmi 1
  add mi hf #%1,-,=
endm

macro jpe 1
  add pe hf #%1,-,=
endm

macro jcs 1
  add cs hf #%1,-,=
endm

macro jcc 1
  add cc hf #%1,-,=
endm

;Ntzliche Befehle
;.............................................................................
macro move 2
  or %c %f %1,-,%2
endm

macro inc 1
  add %c %f -,%1,=
endm

macro dec 1
  sub %c %f -,%1,=
endm

macro in 2
  add tr %f @%1,-,%2
endm

macro out 2
  add tr %f %1,-,@%2
endm

macro not 2
  nor %c %f %1,-,%2
endm

macro clr 1
  and %c %f -,-,%1
endm

macro cmp 2
  sub tr sf %1,%2,-
endm

;Unterprogrammaufrufe
;.............................................................................
macro jsr 1
     sub tr hf -,sp,=     
     add tr hf #*+5,-,(sp)
     add %c hf #%1,-,=
     add tr hf -,sp,=                
endm

macro driver 1
   sub tr hf -,sp,=     
   add tr hf #*+5,-,(sp)
   add %c hf %1,-,=
   add tr hf -,sp,=                
endm

macro sys 1
  sub tr hf -,sp,=             
  add tr hf #*+10,-,(sp)
  sub tr hf -,sp,=
  add tr hf %1,-,(sp)
  add tr hf #$8002,-,=
  add tr hf -,sp,=                
endm

macro rts 0
  add %c hf (sp),-,=
endm
   
;Stackoperationen
;.............................................................................
macro push 1
  sub %c hf -,sp,=
  add %c hf %1,-,(sp)
endm

macro pop 1
  or  %c hf (sp),-,%1
  add %c hf -,sp,=
endm

macro pushz 0
  sub %c hf -,sp,=
  and %c hf -,-,(sp)
endm

macro pushf 0
  sub %c hf -,sp,=
  add %c hf ~-,-,(sp)
endm

macro popf 0
  add %c sf (sp),-,~-
  add %c hf -,sp,=
endm

macro pushall 0
  sub %c hf -,sp,=
  add %c hf d2,-,(sp)
  sub %c hf -,sp,=
  add %c hf d3,-,(sp)
  sub %c hf -,sp,=
  add %c hf d4,-,(sp)
  sub %c hf -,sp,=
  add %c hf d5,-,(sp)
  sub %c hf -,sp,=
  add %c hf d6,-,(sp)
  sub %c hf -,sp,=
  add %c hf d7,-,(sp)
endm

macro popall 0
  or  %c hf (sp),-,d7
  add %c hf -,sp,=
  or  %c hf (sp),-,d6
  add %c hf -,sp,=
  or  %c hf (sp),-,d5
  add %c hf -,sp,=
  or  %c hf (sp),-,d4
  add %c hf -,sp,=
  or  %c hf (sp),-,d3
  add %c hf -,sp,=
  or  %c hf (sp),-,d2
  add %c hf -,sp,=
endm

;Interruptbefehle
;.............................................................................
macro irqoff 0
  and tr hf ~-,#$feff,~dummy
endm

macro irqon 0
  or tr hf ~-,#$0100,~dummy
endm

