;=============================================================================
;FILE VERWALTUNG
;=============================================================================
;include file_sub

equ primaersektor_hi,0
equ primaersektor_lo,1
equ dateilng_sektor,2
equ dateilng_offset,3
equ tiefe,4
equ flags,5
equ kennung_hi,6
equ kennung_lo,7
equ dateiname,8

equ kontrollflags,1
equ driver,2
equ verweis_hi, 3
equ verweis_lo,4
equ verweis_worte,5
equ dateizeiger_sektor,6
equ dateizeiger_offset,7

;-----------------------------------------------------------------------------
;DATEI FFNEN
;-----------------------------------------------------------------------------
;DATEI FFNEN ffnet eine Datei und berprft Zugriffskonflikte. Ein FDB wird
;angelegt.
;Typ: 	1: lesen
;	2: lesen und schreiben
;	3: neuschreiben
;	4: anhngen

;Ressource "Fileverwaltung" allokieren
open:           irqoff				;Unterbrechung verhindern
		cmp        fdblist_in_use,-	;Semaphor berprfen
		move eq    akt_task,fdblist_in_use	;
		irqon
		jeq	   .semok
;(Hier knnte ein Fairnessflag gesetzt werden!)
		jsr	   SWITCHTASK
		jmp	   open

;Parameter holen
.semok:		add        -,sp,d0
		pushall
		move       (d0),d6      ;d6: Zeiger auf Dateinamen holen
		inc        d0
		move	   (d0),d5      ;d5: ffnungsmodus holen


;Standard-FDB aufbauen (Teile der Flags, Magic und Rest auf 0 setzen)
		push       #36		;Speicher fr FDB und temporren...
		jsr	   MALLOC	;...Arbeitsspeicher holen
		inc        sp
		jmi        .ende
		move       d0,d7	;d7:Zeiger auf neuen FDB

;Angegebener Modus zwischen 1 und 4?
		cmp	   -,d5
		move mi	   #111,d0
		jmi	   .memfree	
		cmp	   d5,#4
		move mi	   #111,d0	;Fehler 111: Parameter falsch!
		jmi        .memfree

		inc	   d0
		move 	   #6,(d0)	;Erst mal Read- und Writeflag setzen setzen
		bswp	   -,d5,=
		or	   d5,(d0)	;Im hherwertigen Flagteil: ffnungsmodus
		move	   #6,d1	;6 Wrter im FDB lschen
		inc	   d0
.clrloop:	clr	   (d0)
		inc	   d0
		dec sf	   d1
		jne	   .clrloop
		move	   #$1234,(d0)	;Magic-Worte setzen
		inc	   d0
		move	   #$5678,(d0)

;Dateinamen vorbereiten (evt. gehrt CWD zum Pfad)
;d2: Flag ob CWD mit betrachtet wird oder nicht
		clr        d2		;Flag "Autoerweiterung" lschen
		cmp        #$2f,(d6)	;Dateiname um cwd erweitern ?
		jeq        .start	;Nein, Pfad angegeben (Start mit "/")

;d2 wird jetzt Zeiger auf den Dateinamen und d6 Zeiger auf CWD
		move	   d6,d2	;Zeiger auf Dateiname retten (=Flag setzen)
		push       #cwd		;CWD= im Environment suchen
		jsr        SEARCH_ENV
		inc        sp
		jmi	   .memfree	;Gibt es nicht -> Speicher wieder frei und Ende
		move	   d0,d6	;Erst mal CWD als Dateinamen benutzen
				
;Suche nach dem zugehrigen Gertetreiber
;d0: Zhler
;d1: Zeiger auf Arbeitsspeicher
.start:		inc	   d6		;Treibernamen in Puffer kopieren
		add	   #18,d7,d1	;Dateinamen in letzten Teil des Arbeitsbereiches eintragen
		move	   #5,d0	;Maximal 5 Zeichen kopieren
.drvloop:	move	sf (d6),(d1)	;1 Zeichen kopieren
		jeq	   .searchdrv	;Stringende->Treiber suchen
		cmp	   #$2f,(d1)	;War das Zeichen ein "/"?
		clr eq	   (d1)		;Ja, dort ist nun Stringende...
		jeq	   .searchdrv	;...und Treiber suchen
		inc	   d6
		inc	   d1
		dec	sf d0	
		jne	   .drvloop
		
.drvnotfound:	move	   #106,d0	;Device existiert nicht!
		jmp	   .memfree

.searchdrv:	add        #18,d7,d1	;Treiber suchen
		push       d1
		jsr	   SEARCHDRIVER
		inc        sp
		jmi        .drvnotfound	;Device nicht gefunden?
		add	   #2,d7,d1
		move       d0,(d1)	;Treiberadresse in FDB eintragen

;Dispatchen: Zeichen- oder Blockdriver
		dec        d0           ;Zeiger auf Devicetype
		dec	   d1		;Typ in FDB-Flags eintragen
		or	   (d0),(d1)
		move    sf (d0),-       ;Blockdevice?
		jeq	   .blockdevice ;Ja, Directorybaum durchlaufen
		cmp	   (d6),-	;Nein, Dateiname mu hier enden
		move ne	   #104,d0	;Sonst: Dateiname war falsch
		jne	   .memfree

;Es handelt sich hier um ein Zeichendevice.
;Zugriffskonflikt berprfen.
		push	   d7		;Gert schon geffnet?
		jsr	   FDB_CHECK_X
		inc	   sp
		and	sf #6,d0,-
		jeq	   .append	;Nein, alles ok		
		move	   #115,d0	;Ja, Zugriffskonflikt
		jmp	   .memfree

;.............................................................................
;Blockdevice -> Directorybaum durchlaufen
;d0: Zeiger auf Verweis
.blockdevice:   add        #5,d7,d0 	;Laden des Directory-Entrys in FDB
		push       #8		;Wir wollen 8 Worte (1/2 Direcory-Entry)
		push       (d0)		;Ab Wort Nummer
		dec        d0           
		push       (d0)		;Sektornummer lo
		dec        d0
		push       (d0)		;Sektornummer hi
		add	   #10,d7,d1
		push       d1		;Pufferadresse
		push       -		;Job 1:lesen
		dec        d0
		driver     (d0)
		add        #6,sp
		jmi	   .memfree

;Pfadende erreicht?
		cmp	   (d6),-	;Pfadname zu Ende?
		jeq	   .exist	;Ja, fertig
		add	   #15,d7,d0	;Ist das berhaupt eine Directory?
		and	sf -,(d0),-
		move eq	   #113,d0	;Dir-not-exist Fehler
		jeq	   .memfree
		inc	   d6
		cmp	   (d6),-	;War das vielleicht erst die CWD?
		move eq	   d2,d6	;Ja, jetzt kommt dann der Dateiname

;Nein, nchste Pfadstck bearbeiten
		add        #28,d7,d3	;Nchstes Pfadstck in Arbeitsbereich packen
		push       d3           ;Zeiger auf Zielpuffer
		push       d6           ;Zeiger auf Dateinamen
		jsr        SCAN		;naechsten Teil des Dateinamens lesen
		add        #2,sp
		jmi        .memfree
		move       d0,d6	;Zeiger auf nchsten Teilpfad setzen

;Pfadstck in Verzeichnis suchen
 		push       d3		;Zeiger auf den Namen
		push       d7           ;FDB-Adresse
		jsr        SEARCH_NEXT	;sucht Dateinamen im Directory
		add        #2,sp
		jmi        .exist_nicht ;Dateiname nicht gefunden

;Adresse des Verweises bestimmen
;d3: Zeiger auf Verweis im FDB
.verweis:	push	   d7		;Bestimmung des Verweises
		jsr	   LOG_ABS	;Absolute Sektornummer bestimmen
		inc	   sp
		add	   #3,d7,d3
		move	   d0,(d3)	;SektorNummer-high im FDB eintragen
		inc	   d3
		move	   d1,(d3)	;ebenso SN-low
		add	   #3,d3
		and	   #255,(d3),d0	;ebenso relative Pos im Sektor
		clr	   (d3)		;Dateizeiger auf 0 setzen
		dec	   d3		
		clr	   (d3)
		dec	   d3
		move	   d0,(d3)
		jmp	   .blockdevice	;Und weiter im Pfad

;Datei existiert: Fehler melden bei Neuschreiben
;d0: Flags im FDB
.exist:		add	   -,d7,d0	;Adresse der Flags
		and	sf #$300,(d0),d0
		cmp	   #$300,d0	;Datei neuschreiben?
		move eq	   #110,d0	;Datei-existiert-schon Fehler
		jeq	   .memfree

		add	   -,d7,d0	;Datei zum schreiben ffnen?
		and     sf #$100,(d0),-
		jne	   .sharetest	;nein
		add	   #15,d7,d0
		and	sf #4,(d0),-	;Ja, ist Datei schreibgeschtzt?
		jeq	   .sharetest	;nein
		move ne	   #114,d0	;Ja, Fehler: Datei schreibgeschtzt
		jne	   .memfree

;Test auf Zugriffskonflikt mit anderen Tasks
.sharetest:	push	   d7		;Ist diese Datei schon geffnet?
		jsr	   FDB_CHECK_X
		inc	   sp
		and	sf #4,d0,-	;zum Schreiben?
		move ne	   #115,d0	;Ja: Zugriffskonflikt
		jne	   .memfree
		and	sf #2,d0,-	;zum Lesen?
		jeq	   .append	;Nein, alles ok
		add	   -,d7,d1
		bswp	   (d1),-,d1	;Ja, aber wollen wir schreiben?
		cmp	   -,d1
		move ne	   #115,d0	;Auch das: Zugriffskonflikt
		jne	   .memfree

;Read/Write-Flags und Filepos initialisieren
.append:	add	   -,d7,d1	;d1: Pointer auf Flags
		bswp	   (d1),-,d0	;ffnungsmodus nach d0
		cmp	   #2,d0	;Welcher ffnungsmodus?
		and pe	   #5,(d1)	;Nur Schreiben -> Readflag lschen
		and mi	   #3,(d1)	;Nur lesen -> Schreibflag lschen

		and	sf #4,d0,-	;Soll angehngt werden?
		jeq        .insert	;Nein
		
		add	   #6,d7,d0	;Filepos auf Dateilnge setzen
		add	   #11,d1
		move	   (d1),(d0)	;Maximale Sektornummer
		inc	   d0
		inc	   d1
		move	   (d1),(d0)	;Maximale Wortnummer in diesem Sektor

;Neuen FDB in FDB-List eintragen
.insert:	move	   fdblist,d0	;FDB am Anfang der Liste eintragen
		move	   d7,fdblist
		move	   d0,(d7)

		push	   #20		;FDB auf 20 Worte reduzieren
		push	   d7
		jsr	   MSHRINK
		add	   #2,sp

		clr	sf ~-
		move	   d7,d0

.ende:		clr        fdblist_in_use 	;Semaphor lschen
;(Hier mte Fairnessberprfung eingesetzt werden!)
		popall
		rts

;.............................................................................
;Datei existiert nicht und mu eventuell neu erstellt werden
.exist_nicht:   cmp        (d6),-	;Pfadende erreicht?
		move ne	   #104,d0	;Nein, Fehler
		jne        .memfree

		add	   -,d7,d0	;d0: Zeiger auf Flags in FDB
		bswp	   (d0),-,d0	;Nur zum Lesen ffnen?
		cmp	   -,d0
		move eq	   #109,d0	;Ja, Datei nicht gefunden
		jeq        .memfree

		cmp	   #3,d0	;Neuschreiben?
		jne	   .anfang	;Nein
		add	   -,d7,d0
		and 	   #$ff,(d0)
		or	   #$0400,(d0)	;JA, jetzt nur Anhngen eintragen	   

;Directory-Eintrag erstellen (Directory ist momentan geffnet)
.anfang:	add        #6,d7,d0	;Auf Dateianfang+8 positionieren
		clr        (d0)         
		inc        d0
		move       #8,(d0)

;Freien Platz im Verzeichnis suchen
.lesen: 	push       -		;1 Wort aus Directory lesen
		dec	   sp		;Dummy beim Wort lesen
		push       d7		;FDB-Adresse
		jsr        READ
		add	   #3,sp
		jmi        .found	;EOF? Kein Eintrag gefunden, Dir vergrern
		cmp        d0,-		;Eintrag frei?
		jeq        .found	;Ja freien Eintrag gefunden

	        pushz			;relativ positionieren
		push       d7		;FDB-Adresse
		pushz			;Worte hi
		push       #15		;Worte lo
		jsr        SET_POS      
		add        #4,sp
		jpl	   .lesen	;Nchsten Eintrag berprfen

.found:		add	   #7,d7,d0	;An den Anfang des Entrys positionieren
		and	   #$fff0,(d0)

;Verzeichniseintrag erstellen
		add        #20,d7,d0	;Eintrag fr neue Datei erstellen
		clr        (d0)         ;Primaersektor hi
		inc        d0
		clr        (d0)         ;Primaersektor lo
		inc        d0
		clr        (d0)         ;Dateilaenge hi
		inc        d0
		clr        (d0)         ;Dateilaenge lo
		inc        d0
		clr        (d0)         ;Schachtelungstiefe
		inc        d0
 		clr	   (d0)		;Flags
		inc        d0
		move       timerh,(d0)	;Kennung
		inc        d0
		move       timerl,(d0)	;Kennung
		push       #16		;Anzahl der Worte
		add        #20,d7,d0
		push       d0		;Pufferzeiger
		push       d7		;FDB-Adresse
		jsr        WRITE	;Dateieintrag ablegen
		add        #3,sp
		jmi	   .memfree
		
		add	   #7,d7,d0	;An den Anfang des Entrys positionieren
		cmp	   (d0),-	;Wurde ein neuer Sektor erreicht?
		sub ne	   #16,(d0)	;Nein
		move eq	   #$f0,(d0)	;doch
		dec  eq	   d0	
		dec  eq	   (d0)		;Sektornummer dec		
	
		jmp	   .verweis	;Pfadschleife erneut betreten

;Fehler aufgetreten, Speicher wieder freigeben
.memfree:	move	   d0,d6	;Fehlercode retten
		push	   d7		;Arbeitsspeicher wieder freigeben
		jsr	   MFREE
		inc	   sp
		move	   d6,d0	;Fehlercode zurck
		ror     sf -,-,-

		jmp        .ende

;-----------------------------------------------------------------------------
;DATEI SCHLIEEN
;-----------------------------------------------------------------------------
;Ressource "Fileverwaltung" allokieren
close:          irqoff				;Semaphor setzen
		cmp        fdblist_in_use,-
		move eq    akt_task,fdblist_in_use
		irqon
		jeq	   .semok
;(Hier knnte ein Fairnessflag gesetzt werden!)
		jsr	   SWITCHTASK
		jmp        close

.semok:		add        -,sp,d0
		push	   d2
		move       (d0),d2      ;d2: FDB-Adresse
				
;FDB in Liste suchen, dabei Nachfolger bestimmen
;d1: Zeiger auf FDB-Liste
		move       #fdblist,d1	;Zeiger auf Zeiger auf 1. FDB
.search:        cmp	   (d1),-	;Adresse des nchsten FDB testen
		jeq        .error	;Das war der letzte, gesuchten FDB nicht gefunden
		cmp        (d1),d2	;Ist Nachfolger der gesuchte FDB?
		move ne	   (d1),d1	;Nein, nchsten FDB untersuchen
		jne        .search

		sub	   -,d2,d0	;Gehrt uns der FDB berhaupt?
		cmp	   (d0),akt_task
		jne	   .error	;Nein, nichts tun

		move       (d2),(d1)	;Unser Nachfolger wird Nachfolger unseres Vorgnger
		add        #2,d2,d0

;Alle Schreibpuffer fr dieses Device zurckschreiben
		push       #6           ;Flush
		driver     (d0)         ;Treiberaufruf
		inc        sp		;Keine Fehlerberprfung, da Job nicht
					;allen Treibern bekannt
		
;Magicworte lschen
		add	   #8,d2,d0
		clr	   (d0)
		inc	   d0
		clr	   (d0)

;FDB wieder freigeben           
		push       d2
		jsr	   MFREE
		inc        sp
		clr	sf ~-

.ende: 		clr        fdblist_in_use
;(Hier mte Fairnessberprfung eingesetzt werden!)
        	pop	   d2
		rts

.error:	        ror	sf -,-,-
		move	   #101,d0	;Ungltiges Handle
		jmp	   .ende

;-----------------------------------------------------------------------------
;DATEI LSCHEN
;-----------------------------------------------------------------------------
;Lscht eine Datei in einem Verzeichnis. Es wird eine 0 als 1. und 2. 
;Dateinamenszeichen geschrieben. Die Gre der Dir wird nicht verndert.
;Beim ffnen einer neuen Datei wird dieser Eintrag dann neu beschrieben. 
;Es kann dadurch zu uneindeutigen Aussagen ber die Lnge der Directory kommen.
;Es werden der Reihe nach alle Datensektoren gelscht, danach die Tiefe 
;decrementiert. Somit sind die Verwaltungsektoren der letzten Stufe jetzt die
;neuen Datensektoren. Dieser Vorgang wird solang wiederholt bis die Tiefe
;gleich Null ist. Dann wird der DIR-Eintrag und der Primrsektor 
;gelscht. Vorsicht! Beim Lschen einer DIR mssen vorher alle Datei gelscht
;werden. Sonst werden die durch die Dateien belegten Sektoren nicht wieder
;frei gegeben. 
delete:         add        -,sp,d0
		pushall
		move	   (d0),d0	;d0:FDB-Adresse

;Ist die FDB-Adresse gltig?
		jsr	   FDB_ADRESS
		jmi	   .ende
		move	   d0,d7	;d7:FDB-Adresse

;Ist dies auch eine Blockdevice?
		add	   -,d0
		and     sf -,(d0),-     ;Zeichendevice?
		move ne    #102,d0	;Ja, Befehlszugriff nicht erlaubt
		jne	   .fehler

;Zeiger intialisieren (Dateizeiger, Schachtelungstiefe,..)
		add	   #2,d7,d3	;d3=Treiberadresse
		add	   #dateizeiger_sektor,d7,d6

	        add        #14,d7,d2	;d2: Zeiger auf Schachtelungstiefe
		move       (d2),d2
		
		push	   -		;Auf Dateianfang positionieren
		push	   d7
		pushz
		pushz
		jsr	   SET_POS
		add	   #4,sp

	    	add        #12,d7,d5	;d5:Zeiger auf dateilng_sektor
		inc	   (d5)

;.............................................................................
;Dateilnge der reduzierten Schachtelungstiefe bestimmen
.tiefe:		move	sf d2,-
		jmi	   .clr_v
	    	add        #12,d7,d0	;d5:Zeiger auf dateilng_sektor
		move       (d0),d4
		lsr        d4           ;/2
		lsr        d4           ;/4
		lsr        d4           ;/8
		lsr        d4           ;/16
		lsr        d4           ;/32
		lsr        d4           ;/64
		lsr        d4           ;/128
		inc        d4           ;d4: Neue Dateilaenge
		move	   (d0),d5
		move       d4,(d0)      ;Neue Dateilnge eintragen
		
;Alle Datensektoren dieser Schachtelungstiefe lschen
.lng:           cmp        d5,-		;aktuellle Dateilaenge=0?
		jeq        .exit

;Absolute Sektornummer bestimmen
		push       d7           ;FDB-Adresse
		jsr        LOG_ABS
		inc        sp
		jmi        .clr_v

;Sektor freigeben
		push       d0           ;high
		push       d1           ;low
		push	   d7		;FDB-Adresse
		jsr        BLOCK_FREE	;Sektor freigeben
		add        #3,sp
		jmi	   .fehler
		inc	   (d6)		;Dateizeiger_Sektor dec
		dec	   d5		;Sektorzhler dec
		jmp        .lng

;Schachtelungstiefe reduzieren
.exit:          add        #14,d7,d2	;d2: Zeiger auf Schachtelungstiefe
		dec        (d2)
		move       (d2),d2
		clr	   (d6)
		jmp        .tiefe

;.............................................................................
;Directoryeintrag lschen
.clr_v:         add        #verweis_hi,d7,d0    ;Eintrag des Primaersektors suchen
		move       (d0),d2
		inc        d0
		move       (d0),d5
		inc	   d0
		add        #8,(d0),d0	;Adresse des zu lschenden Wortes
		push       -		;Anzahl der Worte
		push       d0           ;Ab Position
		push       d5           ;Sektornummer lo
		push       d2           ;Sektornummer hi
		push       #.null	;Pufferadresse 
		push       #2           ;Job 2:schreiben
		driver     (d3)
		add        #6,sp      
		jmi	   .ende

		clr     sf ~-
.ende:          popall
		rts

.fehler:  	ror     sf -,-,-
		jmp        .ende

.null:	dw 0

;-----------------------------------------------------------------------------
;DATEI UMBENNEN
;-----------------------------------------------------------------------------
;DATEI UMBENENNEN
;(aktueller Dateiname, neuer Dateiname):ok
rename:         add        -,sp,d0       
		push	   d2
		push       d3
		push       d4
		move       (d0),d3      ;d3: Zeiger auf neuen Namen
		inc        d0
		move 	   (d0),d0	;d0: FDB-Adresse

;Ist FDB-Adresse gltig?
		jsr 	   FDB_ADRESS
		jmi	   .ende
		move	   d0,d2

;Ist dies auch eine Blockdevice?
		inc	   d0		;d0: Zeiger auf FDB, Flags
		and     sf -,(d0),-     ;Blockdevice?
		move ne	   #102,d0	;Nein, Zugriff nicht erlaubt
		ror  ne	sf -,-,-
		jmi        .ende	;nein!

;Speicher fr neuen Namen allokieren
		push	   #8
		jsr	   MALLOC
		inc	   sp
		jmi	   .ende
		move	   d0,d4

;Neuen Namen auf zulssige Zeichen berprfen und kompremieren
		push       d4           ;Zeiger auf 8-Wort Namensfeld
		push       d3           ;Zeiger auf neuen Namen         
		jsr        SCAN		;Dateiname berprfen
		add        #2,sp
		jmi        .fehler

;neuen Dateinamen eintragen
		push       #8           ;8 Worte schreiben
		add        #verweis_worte,d2,d0
		add	   #8,(d0),d1
		push       d1		;Ab Position
		dec        d0
		push       (d0)         ;Sektornummer lo
		dec        d0
		push       (d0)         ;Sektornummer hi
		push       d4           ;Pufferzeiger
		push       #2           ;Job 2:schreiben
		dec        d0
		driver     (d0)         ;Treiberaufruf
		add        #6,sp
		jmi	   .fehler

		clr	   sf ~-	;Flags lschen
		push	   d4
		jsr	   MFREE
		inc	   sp

.ende:		pop        d4
		pop        d3
		pop	   d2
		rts

.fehler:	move	   d0,d2	;Fehlercode retten
		push	   d4
		jsr	   MFREE
		inc	   sp
		move	   d2,d0	;fehlercode restaurieren
		ror	sf -,-,-	;N-Flag setzen
		jmp	   .ende

;-----------------------------------------------------------------------------
;DATEIFLAGS
;-----------------------------------------------------------------------------
;DATEIFLAGS SETZEN
set_flags:      add        -,sp,d0
		move       (d0),d0      ;d0:Zeiger auf Dateinamen

;Ist FDB-Adresse gltig?
		jsr	   FDB_ADRESS
		jmi        .ende

;Ist dies auch eine Blockdevice?
		add        -,d0,d1	;d0 zeigt auf Kontrollflags
		and     sf -,(d1),-	;Block-Oder Zeichendevice
     		move ne    #102,d0   	;Zeichendevice=Fehler
		ror  ne sf -,-,-
		jmi        .ende

;Dateiflags schreiben
		push       -	           	;1 Wort 
		add	   #verweis_worte,d0	;d0:Zeiger auf Verweis_worte
		add        #5,(d0),d1		;Zeiger auf Dateiflags
		push       d1			;Ab Position
		dec        d0
		push       (d0)         	;Sektornummer lo
		dec        d0
		push       (d0)         	;Sektornummer hi
		add	   #6,sp,d1		;Adresse der FLags auf dem Stack
		push       d1           	;Pufferadresse
		push       #2           	;Job 2:schreiben
		dec        d0
		driver     (d0)
		add	   #6,sp
		jmi	   .ende
 
		clr	sf ~-           	;Flags lschen
.ende:		rts

;-----------------------------------------------------------------------------
;GET_FLAGS
;-----------------------------------------------------------------------------
;DATEIFLAGS laden
get_flags:      add        -,sp,d0
		move       (d0),d0      ;d0:Zeiger auf Dateinamen

;Ist FDB-Adresse gltig?
		jsr	   FDB_ADRESS
		jmi	   .ende

;Ist dies auch eine Blockdevice?
		add        -,d0		;d0 zeigt auf Kontrollflags
		and     sf -,(d0),-	;Block-Oder Zeichendevice?
     		move ne    #102,d0   	;Zeichendevice=Fehler
		ror  ne	sf -,-,-
		jmi        .ende

		add eq	   #14,d0	;Zeiger auf Dateiflags
		move eq	   (d0),d0	;Dateiflags nach d0
.ende:		rts

;-----------------------------------------------------------------------------
;DATENZEIGERMANIPULATION
;-----------------------------------------------------------------------------
;POSITIONSAUFRUF(0=REL,1=ABS;FDB-ADRESSE;ANZAHL DER WORTE HIGH; LOW)
set_pos:	add	   -,sp,d0
		push	   d2
		push	   d3
		push	   d4
		push	   d5
		push	   d6
		move       (d0),d4	;d4: Anzahl der worte,l
		inc	   d0
		move       (d0),d3	;d3: Anzahl der worte,h
		inc        d0
		move       (d0),d2	;d2: FDB-Adresse holen
		inc	   d0
		move	   (d0),d5	;d5: Rel oder Abs?

;Ist FDB-Adresse gltig?
		move	   d2,d0
		jsr	   FDB_ADRESS
		jmi	   .ende

;Ist dies auch eine Blockdevice?
		add	   -,d2,d0	;Zeiger auf Flags
		and	sf -,(d0),-	;Zeichen-Device?
		move ne    #102,d0	;Ja, kein Positionieren mglich
		ror  ne	sf -,-,-
		jmi	   .ende

		add	   #6,d2,d0	;Dateizeiger Sektor
		add	   -,d0,d1	;Dateizeiger Wort

		cmp	   d5,-		;Relative Positionierung
		jne	   .calc	;Nein, absolut

;POSITIONIEREN RELATIV VORWRTS;
		bswp	   -,(d0),d5
		or	   (d1),d5	;Zeiger lo in Worten
		add     sf d5,d4	;low	
		bswp	   (d0),-,d5	;Zeiger hi in Worten
		addc	   d5,d3

;POSITIONIEREN ABSOLUT DATEIZEIGER (handle, anzahl der worte)
.calc:		bswp	   d4,d3,d5	;d5=Sektoren
		and        #$ff,d4,d6	;d6=Worte

;POSITIONIEREN ABSOLUT DATEIZEIGER (handle, Sektoren, Worte)
.abs:		add	   #12,d2,d3	;Zeiger auf Dateilnge
		add	   -,d3,d4
		cmp	   d5,(d3)	;Sektorlnge mglich?
		jpe	   .pos		;ja
		cmp	   d6,(d4)	;Wortlnge mglich?
		jpl	   .pos		;ja

		move       (d3),(d0)	;Dateizeiger auf Fileende
		move       (d4),(d1)
		ror	sf -,-,-	;N-Flag setzen
		move	   #105,d0	;EOF erreicht
		jmp	   .ende

.pos:		move       d5,(d0)	;Dateizeiger positionieren            
		move       d6,(d1)	;Dateizeiger positionieren
		clr	sf ~-		;Flags lschen
.ende:		pop	   d6
		pop	   d5
		pop	   d4
		pop	   d3
		pop	   d2
	        rts 

;-----------------------------------------------------------------------------
;GET_POS
;-----------------------------------------------------------------------------
;POSITON DATEIZEIGER IN WORTEN ERMITTELN (FDB-ADRESSE)
;	:d0 Position in Worten high
;	:d1 Position in Worten low
get_pos:	add	   -,sp,d1
		push	   d2
		move	   (d1),d2	;d2: FDB-Adresse

;Ist FDB-Adresse gltig?
		move	   d2,d0
		jsr	   FDB_ADRESS
		jmi	   .ende

;Ist dies auch eine Blockdevice?
		add	   -,d2,d0	;Zeiger auf Flags
		and	sf -,(d0),-	;Blockdevice?
		move ne	   #102,d0	;Nein, Zugriff nicht erlaubt
		ror  ne sf -,-,-	;N-Flag setzen
		jmi  	   .ende	

;Dateiposition bermitteln
;Z-Flags ist hier gesetzt 
		add	   #dateizeiger_sektor,d2
		bswp	   (d2),-,d0	;Hi-Wort
		bswp	   -,(d2),d1	;Lo-Wort
		inc	   d2
		or	   (d2),d1
.ende:		pop	   d2
		rts
	
;-----------------------------------------------------------------------------
;GET_LNG
;-----------------------------------------------------------------------------
;DATEILNGE ERMITELN(FDB-ADRESSE):d0 Lnge in Worten high
;				 :d1 Lnge in Worten low
get_lng: 	add	   -,sp,d0

;Ist FDB-Adresse gltig?
		move	   (d0),d0
		jsr	   FDB_ADRESS
		jmi	   .ende

;Ist dies auch eine Blockdevice?
		add	   -,d0,d1	;d1:Zeiger auf Treiberadresse
		and	sf -,(d1),-	;BLock- oder Zeichendevice?
		move ne    #102,d0	;Zeichendevice!, Zugriff nicht erlaubt!
		ror  ne	sf -,-,-	;N-Flag setzen
		jmi	   .ende	;Nein!
		
;Dateilnge bermitteln.
;Z-Falg ist hier gesetzt.
		add	   #12,d0,d1	;Zeiger auf Dateilnge_sektor
		bswp	   (d1),-,d0	;Hi-Wort
		bswp	   -,(d1),d1	;Lo-Wort
		inc	   d0
		or	   (d0),d1
.ende:		rts

;-----------------------------------------------------------------------------
;TRANSFER
;-----------------------------------------------------------------------------
;READ(FDB-ADRESSE,ZEIGER AUF DATEN,ANZAHL=0:STRING,=1 WORT, x=BLOCK)
read:		add	   -,sp,d0
		pushall
		move	sf (d0),d7		;d7:FDB-Adresse (0=Stdout)
		add eq	   #20,akt_task,d1	;Adresse des Stdin-Handles
		move eq	sf (d1),d7
		move eq	   #105,d0		;Nulldevice -> EOF und Ende
		jeq	   transferende.fehler
		move	   d0,d2

;Ist FDB-Adresse gltig?
		move	   d7,d0		;FDB-Adresse zulssig?
		jsr	   FDB_ADRESS
		jmi	   transferende.fehler

;Zugriff erlaubt? (Datei zum lesen geffnet?)
		add	   -,d7,d1		;Read-Flag gesetzt?
		and 	sf #2,(d1),-
		move eq	   #102,d0		;Nein, Zugriff nicht erlaubt
		jeq	   transferende.fehler
		add	   #2,d7,d5		;d5:Treiberadresse
		move	   (d5),d5

		inc	   d2
		move	   (d2),d6		;d6:Pufferadresse
		inc	   d2
		move	sf (d2),d2		;d2:Anzahl
		move eq	   #111,d0		;Anzahl=0: Falscher Parameter
		jeq	   transferende.fehler
		cmp	   -,d2
		jeq	   wortread		;=1 WORT

;.............................................................................
;sonst BLOCK EINLESEN
blockread:	and	sf -,(d1),-	;Block oder Zeichendevice?
		jeq	   .blockdevice
		move	   d2,d4	;Anzahl merken
		
.zeichendevice: push	   -		;1 Zeichen vom Device holen
		driver	   d5
		inc	   sp	
		sub mi	   d2,d4,d1	;d1 enthlt Anzahl der bermittelten Zeichen
		jmi	   transferende.fehler
		move	   d0,(d6)	;Alles ok, Wort in Puffer schreiben
		inc	   d6		;Pufferzeiger++
		dec	sf d2		;Anzahl--
		jne	   .zeichendevice
		move	   d4,d1	;es wurden alle Zeichen bertragen
		jmp	   transferende

.blockdevice:	clr	   d1
.loop:		cmp	   d2,-		;letztes Zeichen kopiert
		jeq	   transferende	;Ja, fertig
		add	   #7,d7,d0	
		sub	   (d0),#256,d4	;Anzahl der bertragbaren Worte im aktuellen Sektor
		cmp	   d2,d4	;Reicht der Platz im aktuellen Sektor?
		sub  mi	   d4,d2	;Nein, neue Lnge=Alte Lnge-Anzahl bertragener Worte
		move pl	   d2,d4	;Ja, nur soviel bertragen wie ntig
		clr  pl    d2		;...und dann nichts mehr
		push	   d1
		jsr	   IN
		pop	   d3
		add	   d3,d1	;Aufsummieren der bertragenen Wrter
		jmi	   transferende.e2
		add	   d4,d6	;Pufferzeiger um Anzahl bertragener Worte weiterschalten
		jmp	   .loop

;.............................................................................
;WORTLESEN 
wortread:	and	sf -,(d1),-		;Block oder Zeichendevice?
		jeq	   .blockdevice		;Block!

		push	   -			;Job 1:Zeichen (Status) lesen
		driver	   d5			;Teiberaufruf
		inc	   sp	
		jmp	   transferende.e2	;Zeichen in d0

.blockdevice:	move	   -,d4		;Anzahl der zulesenden Worte=1
		add	   #18,d7,d6	;Pufferbereich (im FDB)
		jsr	   IN		;Read-Routine
		move pl	   (d6),d0	;Ergebnis aus Puffer nach d0
		jmp	   transferende.e2

;-----------------------------------------------------------------------------
;WRITE(FDB-ADRESSE,ZEIGER AUF PUFFER,ANZAHL=0:STRING,=1 WORT, x=BLOCK)
write:		add	   -,sp,d0
		pushall
		move	sf (d0),d7		;d7:FDB-Adresse (0=Stdout)
		add eq	   #21,akt_task,d1	;Adresse des Stdout-FDB holen
		move eq	sf (d1),d7
		jeq	   transferende		;Nulldevice? -> Fertig
		move	   d0,d2

;Ist FDB-Adresse gltig?
		move	   d7,d0		;FDB-Adresse zulssig?
		jsr	   FDB_ADRESS
		jmi	   transferende.fehler

		add	   -,d7,d1		;Schreib-Flag gesetzt?
		and 	sf #4,(d1),-
		move eq	   #102,d0		;Nein: Unerlaubter Zugriff
		jeq	   transferende.fehler
		add	   #2,d7,d5		;d5:Treiberadresse
		move	   (d5),d5

		inc	   d2
		move	   (d2),d6		;d6:Pufferadresse
		inc	   d2
		move	sf (d2),d2		;d2:Anzahl
		jeq	   stringwrite		;0: STRING
		cmp	   -,d2
		jeq	   wortwrite		;1: WORT

;.............................................................................
;sonst BLOCK TRANSFERIEREN
blockwrite:	and	sf -,(d1),-	;Block oder Zeichendevice?
		jeq	   .blockdevice	;Block!

.zeichendevice: push	   (d6)		;Zeichen an Driver ausgeben
		push	   #2
		driver	   d5		;Teiberaufruf
		add	   #2,sp
		jmi	   transferende.e2
		inc	   d6		;Pufferzeiger++
		dec	sf d2		;Anzahl--
		jne	   .zeichendevice
		jmp	   transferende

.blockdevice:	cmp	   d2,-		;letztes Zeichen kopiert
		jeq	   transferende	;Ja, fertig
		add	   #7,d7,d3	
		sub	   (d3),#256,d4	;Anzahl der bertragbaren Worte im aktuellen Sektor
		cmp	   d2,d4	;Reicht der Platz im aktuellen Sektor?
		sub  mi	   d4,d2	;Nein, neue Lnge=Alte Lnge-Anzahl bertragener Worte
		move pl	   d2,d4	;Ja, nur soviel bertragen wie ntig
		clr  pl    d2		;...und dann nichts mehr
		jsr	   OUT		
		jmi	   transferende.e2
		add	   d4,d6	;Pufferzeiger um Anzahl bertragener Worte weiterschalten
		jmp	   .blockdevice

;.............................................................................
;WORT TRANSFERIEREN
wortwrite:	and	sf -,(d1),-	;Blockdevice?
		jeq	   .blockdevice	;Ja

		push	   d6		;Zeichen an Zeichendevice ausgeben
		push	   #2
		driver	   d5
		add	   #2,sp
		jmp	   transferende.e2

.blockdevice:	move	   -,d4		;Anzahl der zu schreibenden Worte=1
		add	   #8,sp,d6	;Adresse des Zeichens im Stack
		jsr	   OUT		;Read-Routine
		jmp	   transferende.e2

;.............................................................................
;STRINGWRITE
stringwrite:	and	sf -,(d1),-	;Block oder Zeichendevice?
		jeq	   .blockdevice	;Block!

		push	   d6		;String an Treiber ausgeben
		push	   #3
		driver	   d5
		add	   #2,sp
		jmp	   transferende.e2

.blockdevice:	move	   d6,d0	;Temporrpointer, d2 ist schon 0
.length:	cmp	   (d0),-	;Stringlnge ermitteln
		jeq	   blockwrite.blockdevice
		inc  	   d2		;Anzahl++
		inc  	   d0		;Pointer++
		jmp	   .length

;-----------------------------------------------------------------------------
;EXIT fr beide bertragungsroutinen
transferende:	clr	sf ~-		;Flags lschen
.e2:		popall
		rts				
.fehler:	ror	sf -,-,-	;N-Flag setzen
		jmp	   .e2

;-----------------------------------------------------------------------------
;READAUFRUF nur durch BS zugnglich
;EOF berprfung
in:		push	   d2
		add	   #6,d7,d0	;Sind wir im letzten Sektor?
		add	   #12,d7,d1	;d1: Dateilnge in Sektoren
		cmp	   (d0),(d1)
		clr	   d2		;Erst mal kein Fehler
		jne	   .noeof	;Nein,  Fileende wird nicht berschritten
		inc	   d0
		inc	   d1
		add	   (d0),d4,d3	;Wortpos nach Leseoperation
		cmp	   d3,(d1)
		sub mi	   (d0),(d1),d4	;EOF wrde berschritten werden -> weniger lesen
		move mi	   #105,d2	;Fehler: EOF

;Absolute Sektornummer ermitteln
.noeof:		push 	   d7		;Lesesektorposition berechnen
		jsr	   LOG_ABS
		inc	   sp
		jmi	   .ende

;Daten einlesen
		add	   #7,d7,d3
		push	   d4		;Anzahl der  Worte
		push	   (d3)		;Ab Position d0
		push	   d1		;Sektornummer lo
		push	   d0		;Sektornummer hi
		push	   d6		;Zeiger auf Puffer
		push	   -		;Job 1:lesen
		driver	   d5		;Treiberaufruf
		add	   #6,sp
		jmi	   .ende

;Dateizeiger erhhen
		add	   d4,(d3)	;Dateizeiger lo erhhen
		cmp	   #256,(d3)
		and	   #$ff,(d3)	
		dec	   d3
		inc eq	   (d3)		;Dateizeiger hi erhhen

		move	   d4,d1	;Anzahl der gelesenen Zeichen
		move	sf d2,d0	;Falls kein EOF ist d2=0
		ror ne	sf -,-,-	;N-Flag bei EOF
.ende:		pop	   d2
		rts

;-----------------------------------------------------------------------------
;WRITEAUFRUF nur durch BS zugnglich
;Ist Datei lnger geworden?
out:		push	   d2
		add	   #7,d7,d0	;Stehen wir am Anfang eines neuen Sektors?
		cmp	   (d0),-	;Nein, wir stehen mitten in einem Sektor
		jne	   .calc
		add	   #6,d0	;Steht das Dateiende an einer Sektorgrenze?
		cmp	   (d0),-	;Nein, wir brauchen keinen neuen Sektor
		jne	   .calc
		dec	   d0		;Stehen wir am EOF?
		add	   #6,d7,d1	;Dateizeiger Worte
		cmp	   (d1),(d0)
		jne	   .calc	;Nein

;Dateilnge hat sich verndert, wir brauchen einen neuen Sektor
		push       d7		;Einen neuen Datensektor an die Datei anfgen
		jsr  	   SEKTOR_FORDERN
		inc	   sp
		jmi	   .ende

;Hier ist nun sichergestellt, da an der Schreibposition ein gltiger Datensektor liegt
.calc:		push 	   d7		;Schreibsektorposition berechnen
		jsr	   LOG_ABS
		inc	   sp
		jmi	   .ende

;Daten ablegen
		push	   d4		;Anzahl der  Worte
		add	   #7,d7,d3
		push	   (d3)		;Ab Position
		push	   d1		;Sektornummer lo
		push	   d0		;Sektornummer hi
		push	   d6		;Zeiger auf Puffer
		push	   #2		;Job 2:schreiben
		driver	   d5
		add	   #6,sp
		jmi	   .ende

;Filepos weiterschalten
		add	   #7,d7,d0	;Zeiger auf Dateipos-Offset
		add	   d4,(d0)	;Dateizeiger lo erhhen
		cmp	   #256,(d0)	;Sektorgrenze erreicht?
		and	   #$ff,(d0)	;Offset normieren
		dec	   d0
		inc eq	   (d0)

;Dateilnge anpassen
		add	   #12,d7,d1
		cmp	   (d1),(d0)	;Sektoranzahl<Aktueller Sektor
		jmi	   .notbigger	;Ja, Datei hat sich nicht vergrert
		inc	   d0
		inc	   d1
		jpe	   .bigger	;Umgekehrt -> Datei hat sich vergert
		cmp	   (d0),(d1)	;Dateizeigeroffset > Dateilngenoffset?
		jpl	   .notbigger	;Nein

.bigger:	move	   (d0),(d1)	;Neue Dateilnge im FDB eintragen
		dec	   d0
		dec	   d1
		move	   (d0),(d1)

;neue Dateilnge abspeichern
		push	   #5		;Neuen Directoryentry schreiben
		add	   #5,d7,d0
		push	   (d0)		;Dir-Verweis-Offset
		dec	   d0
		push	   (d0)		;Dir-Verweis-Sektornummer lo
		dec	   d0
		push	   (d0)		;Dir-Verweis-Sektornummer hi
		add	   #10,d7,d1	;Zeiger auf neuen Entry
		push	   d1
		push	   #2		;Job 2:schreiben
		driver	   d5
		add	   #6,sp
		jmi	   .ende
.notbigger:	clr	sf ~-		;Flags lschen
.ende:		pop	   d2
		rts

;------------------------------------------------------------------------------
;CD
;------------------------------------------------------------------------------
;Change Directory
cd:		push	   d2
		push	   d3
		push	   d4
		add 	   #4,sp,d3	;Zeiger auf Stringzeiger
		move	   (d3),d3	;d3: Stringzeiger

;Arbeitsspeicher allokieren
		push	   #256
		jsr	   MALLOC	;Speicher anfordern
		inc	   sp
		jmi	   .ende
		move	   d0,d2

;Welche Form des CD?
		cmp	   (d3),#$2e	;"..",cwd krzen?
		jne	   .new		;Nein
		add	   -,d3,d0
		cmp	   (d0),#$2e
		jeq	   .cut		;ja

;Existiert dieses Verzeichnis?
.new:		push	   -		;Ist Dir zulssig?
		push	   d3		;Zum lesen ffnen
		jsr	   OPEN		;berprfen ob Dir existiert
		add	   #2,sp
		jmi	   .fehler	;neue cwd exisitiert nicht

		add	   #15,d0,d1	;Handelt es sich bei der Datei um eine Dir?
		and	sf -,(d1),d4	;Dir-Flag gesetzt

		push	   d0		;Datei wieder schlieen
		jsr	   CLOSE
		inc	   sp

		move	sf d4,-		;D-Flag gesetzt?
		move eq    #113,d0
		jeq	   .fehler	;Nein

;Im Arbeitspuffer das neue CWD aufbauen
.cut:		move	   d2,d4
		move	   #$63,(d2)	;"cwd=" in Puffer eintragen
		inc   	   d2
		move	   #$77,(d2)
		inc   	   d2
		move	   #$64,(d2)
		inc   	   d2
		move	   #$3d,(d2)
		inc   	   d2

		cmp	   (d3),#$2f	;"/", Neue cwd?
		jeq	   .copy	;ja

		push	   #cwd		;cwd bestimmen
		jsr	   SEARCH_ENV
		inc	   sp
		jmi	   .fehler

.eintragen:	cmp	   (d0),-	;Alte cwd hinzufgen
		move ne    (d0),(d2)
		inc  ne	   d0
		inc  ne	   d2
		jne   	   .eintragen

		cmp	   (d3),#$2e	;".",cwd krzen?
		jne	   .copy	;Nein, Srring kopieren
		add	   -,d3,d0
		cmp	   (d0),#$2e
		move eq    d2,d3
		dec  eq	   d2
		clr	   d0
		jeq	   .check	;ja

.copy:		cmp	   (d3),-	;String in cwd kopieren
		move ne	   (d3),(d2)		
		inc  ne	   d3
		inc  ne	   d2
		jne	   .copy
.last:		move 	   #$2f,(d2)	;"/",Trennzeichen anhngen
		inc	   d2
		clr	   (d2)

.new_set:	push	   d4		;genderte cwd in Env.-Bereich eintragen
		jsr	   SET_ENV
		inc 	   sp
		jmi	   .fehler

.ende:		push	   d4
		jsr	   MFREE
		inc	   sp
		clr	sf ~-
.ende2:		pop	   d4
		pop	   d3
		pop	   d2
		rts
.fehler:	push	   d0		;Fehlercode retten
		push	   d4
		jsr	   MFREE
		inc	   sp
		pop	   d0		;Fehlercode restaurieren
		ror	sf -,-,-	;N-Flag setzen
		jmp	   .ende2

;cwd soll gekrzt werden.
.check:		dec	   d3		;berprfung ob Krzung zulssig
		cmp	   (d3),#$2f	;d3 steht am Ende der Cwd,"/"?
		inc eq	   d0
		cmp	   d0,#2
		jmi	   .delete
		cmp	   (d3),#$3d
		jeq	   .ende
		jmp	   .check				

;Es exitiert noch min. ein Eintrag in der cwd, diesen vom Ende her bis zu
;einem / lschen.
.delete:	clr	   (d2)		;Rckwrts lschen
		dec	   d2
		cmp	   (d2),#$2f	;"/"?
		jeq	   .new_set
		jmp	   .delete

cwd:		dw "cwd=",0		;Suchstring im Env.-Bereich

;-----------------------------------------------------------------------------
;SET_ENV 
;-----------------------------------------------------------------------------
;Set environment
;Setzt eine Enivronementvariable.
set_env:	add	   -,sp,d0		;Zeiger auf Strg-Pointer
		push	   d2
		push	   d3
		move	   (d0),d2		;d2:Stringpointer

;Falls Env.-Var. existiert -> lschen
		push	   d2			;alte gleichnamige Variable...
		jsr	   CLR_ENV		;...lschen
		inc	   sp

;Lnge der Variablen bestimmen
		move	   d2,d0		;Lnge des neuen Strings berechnen
.length:	cmp	   (d0),-		;Ende des Strings?
		inc 	   d0
		jne	   .length

;Gre des Env.-Bereiches bestimmen
		sub	   d2,d0,d3		;d3:Lnge des Strings (mit der 0)
		inc	   d3			;Wir brauchen aber 1 Wort mehr fr zustzliche 0
		sub	   #2,akt_task,d1	;Lnge des TDB
		add	   (d1),d1		;Pointer auf 1. Wort nach ENV-Bereich
		add	   #22,akt_task,d0	;Environmentbereichsadresse

;Freie Position im Env.-Bereich suchen und Var. eintragen, falls Lnge reicht
.search:	cmp	   (d0),-	;Freier Platz?
		jeq	   .found	;Ja,gefunden
.loop:		cmp	   (d0),-	;Zur nchsten Variablen
		inc	   d0
		jne	   .loop
		jmp	   .search

.found:		sub	   d0,d1	;Reicht der Platz noch aus?
		cmp	   d3,d1		
		move mi    #107,d0
		jmi	   .ende	;Nein, Fehler

.copy:		move	sf (d2),(d0)	;Environmentvariable kopieren
		inc	   d0
		inc	   d2
		jne	   .copy		
		clr	   (d0)		;Und 1 Null mehr

		clr	sf ~-		;Kein Fehler
.ende:		pop	   d3
		pop	   d2
		rts

;-----------------------------------------------------------------------------
;CLR_ENV
;-----------------------------------------------------------------------------
;Clear Environment
;Lscht eine Environmentvariable
clr_env:	push	   d2
		add	   #22,akt_task,d0	;Environmentbereichsadresse

;Var. suchen
.search:        cmp	   (d0),-	;Eintrag suchen
		jeq  	   .ende	;Kein String gefunden
		move	   d0,d2	;Position merken fr clear
		add	   #2,sp,d1	;Zeiger auf Strg-Pointer
		move	   (d1),d1	;d1:Stringpointer

.found:		cmp	   (d0),(d1)	;Gleiche Zeichen?
		jne	   .go_on	;Nein, zum nchsten Env-String
		cmp	   #$3d,(d0)	;"=", Abbruch
		jeq	   .remove	;Variable gefunden, lschen
		inc	   d0
		inc	   d1
		jmp	   .found
.go_on:		cmp	   (d0),-	;Zum nchsten String weiterschalten
		inc	   d0
		jne	   .go_on	
		jmp	   .search

;Eintrag lschen, indem der Rest des Env. bereiches an diese Position aufrckt
.remove:	sub	   #2,akt_task,d1 ;Lnge des TDB
		add	   (d1),d1	  ;Adresse des 1. Worts nach ENV-Bereich

.nextvar:	cmp	   (d0),-	;Suche nach der nchsten Variablen
		inc  	   d0
		jne	   .nextvar
.copy:		move	   (d0),(d2)	;Variable gefunden, verschieben!
		inc	   d0
		inc	   d2
		cmp	   d0,d1	;Env-Ende?
		jne	   .copy	;Nein, weiterverschieben

.clear:		clr	   (d2)		;Rest des Env-Bereichs lschen
		inc	   d2
		cmp	   d2,d1
		jne	   .clear

.ende:		pop	   d2
		rts

;-----------------------------------------------------------------------------
;SEARCH_ENV
;-----------------------------------------------------------------------------
;Search Environment
;Sucht eine Environementvariable
search_env:	add	   #22,akt_task,d0	;Environmentbereichsadresse
.search:        cmp	   (d0),-		;Eintrag leer?
		jeq  	   .errorend		;Ja, String nicht gefunden
		add	   -,sp,d1		;Zeiger auf Strg-Pointer
		move	   (d1),d1		;d1:Stringpointer

.found:		cmp	   (d0),(d1)	;Gleiche Zeichen?
		jne	   .go_on	;Nein, zum nchsten Env-String
		cmp	   (d0),#$3d	;"=", Abbruch
		inc	   d0
		rts eq			;Variable gefunden, fertig
		inc	   d1
		jmp	   .found
.go_on:		cmp	   (d0),-	;Nchste Variable suchen
		inc	   d0
		jne	   .go_on	
		jmp	   .search

.errorend:	ror	sf -,-,-	;Variable nicht gefunden-> N-Flag setzen
		rts

;-----------------------------------------------------------------------------
;LOAD PROGRAM 
;-----------------------------------------------------------------------------
;Programm wird geladen und reloziert. d0 enthlt die Startadresse des Programms.
prg_load:	add	   -,sp,d0
		push	   d2
		push	   d3

;Datei zum Lesen ffnen
		push       -		;zum lesen ffnen
		push       (d0)		;Pointer auf Dateinamen
		jsr        OPEN
		add        #2,sp
		jmi        .exit
	        move       d0,d2        ;d2:File-Handle

;Ist diese Datei ausfhrbar?
		add	   #15,d0	;Zeiger auf Dateiflags im FDB
		and	sf #2,(d0),-	;Executable-Flag gesetzt?
		move eq	   #117,d0	;Nein
		ror  eq sf -,-,-	;N-Flags setzen
		jmi	   .fehler

;Lnge des PRGs im Speicher ermitteln
		push       -		;1 Wort lesen (Speicherbedarf des Programes)
		dec	   sp		;Dummy, wegen 1 Wort lesen
		push       d2
		jsr        READ
		add        #3,sp
		jmi	   .fehler

;Entsprechend groen Speicher anfordern
		push       d0		;Speicher anfordern fr Programm
		jsr	   MALLOC
		inc        sp
		jmi        .fehler
		move       d0,d3	;d3: Speicheradresse des Programms

;Lnge des initialisierten Bereich betsimmen
		push       -		;Nchstes Wort: Lnge des zu ladenden Programmteils
		dec	   sp		;Dummy, wegen 1 Wort lesen
		push       d2
		jsr        READ
		add        #3,sp
		jmi	   .memfree

;Diesen Bereich laden
		push       d0           ;Programmtext laden
		push       d3
		push       d2
		jsr        READ
		add        #3,sp
		jmi        .memfree

;Relozieren
.wortweise:     push	   -		;1 Wort 'Relo'-Informationen lesen
		dec	   sp		;Dummy
		push       d2
		jsr        READ
		add        #3,sp
		jmi        .ende	;Fertig reloziert
		add        d3,d0	;Wort relozieren
		add        d3,(d0)
		jmp        .wortweise

;Bei Fehler Speicher wieder freigeben und Datei schlieen
.memfree:	push 	   d3
		move	   d0,d3	;Fehlercode retten
		jsr	   MFREE
		inc	   sp
		move       d3,d0	;Fehlercode restaurieren
.fehler:	move       d0,d3	;Fehlercode retten
		push       d2
		jsr        CLOSE	;Geffnete Datei wieder schlieen
		inc        sp
		move       d3,d0	;Fehlercode restaurieren
		ror     sf -,-,-	;N-Flag setzen
		jmp	   .exit

.ende:		push       d2
		jsr        CLOSE	;Geffnete Datei wieder schlieen
		inc        sp
		clr	sf ~-		;Flags lschen
		move	   d3,d0	;Startadresse vom Prg zurckgeben
.exit:		pop	   d3
		pop	   d2
		rts

;-----------------------------------------------------------------------------
;FEHLERAUSGABE AN STANDARDOUT 
;-----------------------------------------------------------------------------
fehler:		add	   -,sp,d0
		move	   (d0),d0	;Fehlercode nach d0 holen

		bswp	sf d0,-,d1	;Treiberfehler
		jne	   .treiberfehler
		sub        #100,d0	;Fehlercode -100
		add        #.fehlertabelle,d0
.out:		pushz			;Fehler-String ausgeben
		push       (d0)
		pushz
		jsr        WRITE
		add        #3,sp
		rts

;Es ist ein SCSI-Fehler, Statuscode betrachten
.treiberfehler:	and	   #$ff,d1,d0
		sub	   #2,d0
		add	   #.treibererrors,d0
		jmp	   .out

.fehlertabelle: dw      .noexe
		dw      .geschlossen
		dw      .zugriff
		dw      .speicher
		dw      .form
		dw      .eof
		dw      .device
		dw      .env
		dw      .laenge
		dw      .exist_not
		dw	.exist
		dw      .parameter
		dw      .disk_full
		dw      .nodir
		dw      .writeprotect
		dw      .konflikt
		dw	.dir
		dw	.executable
		dw	.keinzeichen

.noexe:		dw 10,13,"Es gibt keine ausfhrbare Datei dieses Namens!",13,10,0
.geschlossen:   dw 10,13,"Ungltiges Handle!",13,10,0
.zugriff:       dw 10,13,"Befehlszugriff nicht erlaubt!",13,10,0
.speicher:      dw 10,13,"Zuwenig Speicherplatz!",13,10,0
.form:          dw 10,13,"Dateiname hat falsches Format!",13,10,0
.eof:           dw 10,13,"End-Of-File erreicht!",13,10,0
.device:        dw 10,13,"Device existiert nicht!",13,10,0
.env:           dw 10,13,"Environmentbereich zu klein!",13,10,0
.laenge:        dw 10,13,"Maximale Dateilnge (32MB) erreicht!",13,10,0
.exist_not:	dw 10,13,"Datei existiert nicht!",13,10,0
.exist:		dw 10,13,"Datei existiert schon!",13,10,0
.parameter:     dw 10,13,"Parameter falsch!",13,10,0
.disk_full:     dw 10,13,"Datentrger voll!",13,10,0
.nodir:		dw 10,13,"Directory existiert nicht!",13,10,0
.writeprotect:  dw 10,13,"Datei ist schreibgeschtzt!",13,10,0
.konflikt:	dw 10,13,"Zugriffskonflikt auf mehrfach benutzte Datei!",13,10,0
.dir:		dw 10,13,"Directory ist nicht geleert!",13,10,0	
.executable:	dw 10,13,"Datei ist nicht ausfhrbar!",13,10,0
.keinzeichen:	dw 10,13,"Es liegt kein Zeichen an!",13,10,0

.treibererrors:	dw .nr,.me,.he,.ua,.rs,.wp,.z,.hs,.z,.z,.z,.z,.se

.z:		dw 0
.nr:		dw 10,13,"SCSI-Laufwerk nicht bereit!",13,10,0
.me:		dw 10,13,"SCSI-Medienfehler!",13,10,0
.he:		dw 10,13,"SCSI-Hardware-Fehler!",13,10,0
.ua:		dw 10,13,"Ungltige SCSI-Anfrage!",13,10,0
.rs:		dw 10,13,"SCSI-Gert wurde zurckgesetzt!",13,10,0
.wp:		dw 10,13,"Medium in SCSI-Laufwerk schreibgeschtzt!",13,10,0
.hs:		dw 10,13,"Herstellerspezifischer SCSI-Fehler aufgetreten!",13,10,0
.se:		dw 10,13,"SCSI-Schreibfehler!",13,10,0



;-----------------------------------------------------------------------------
;MAKE DIRECTORY
;-----------------------------------------------------------------------------
md:		add	   -,sp,d0
		push	   d2
		move	   (d0),d2	;Zeiger auf Dateinamen

;Verzeichnis ffnen
		push	   #3		;Zum Neuschreiben ffnen
		push	   d2		;Dateiname
		jsr	   OPEN		;Datei erzeugen
		add	   #2,sp
		jmi	   .ende
		move 	   d0,d2
		
;D-Flag setzen
		push	   -
		push	   d0
		jsr	   SET_FLAGS	;Set-D-Flag
		add	   #2,sp

;Datei wieder schlieen
		push	   d2		;Datei wieder schlieen
		jsr	   CLOSE
		inc	   sp

.ende:		pop	   d2
		rts


;-----------------------------------------------------------------------------
;REMOVE DIRECTORY
;-----------------------------------------------------------------------------
rd:		add	   -,sp,d0
		push	   d2
		move	   (d0),d2	;d2: Zeiger auf Dateinamen

;Datei zum Lesen ffnen
		push	   #2		;zum lesen und schreiben ffnen
		push	   d2		;Dateiname
		jsr	   OPEN		;Directory ffnen
		add	   #2,sp
		jmi	   .ende
		move	   d0,d2

;Ist dies auch eine Blockdevice?
		add	   -,d0
		and	sf -,(d0),-	;Block oder Zeichen Device?
		move ne	   #102,d0
		jne	   .fehler

;Ist es eine Directory?
		add	   #14,d0	;Zeiger auf Dateiflags
		and	sf -,(d0),-	;Ist D-Flag gesetzt?
		move eq	   #113,d0
		jeq	   .fehler

;Ist dieses Verzeichnis auch leer?
		push	   -		;absolut Positionieren
		push	   d2
		pushz
		push	   #8
		jsr	   SET_POS
		add	   #4,sp
		jmi	   .del

.read:		push	   -		;Anzahl
		dec	   sp
		push	   d2		;FDB-Adresse
		jsr	   READ		;READ
		add	   #3,sp
		jmi	   .fehlercheck
		cmp	   d0,-
		move ne	   #116,d0
		jne	   .fehler

		pushz
		push	   d2
		pushz
		push	   #15
		jsr	   SET_POS
		add	   #4,sp
		jpl	   .read

.fehlercheck:	cmp	   d0,#105	;EOF-Fehler?
		jne	   .fehler	;Nein

;Verzeichnis lschen
.del:		push	   d2
		jsr	   DELETE
		inc	   sp
		jmi	   .fehler
		
;Verzeichnis schlieen, um FDB freizugeben
		push	   d2	
		jsr	   CLOSE
		inc	   sp
		clr	sf ~-
.ende:		pop	   d2
		rts	   

.fehler:	push	   d0		;Fehlercode retten
		push	   d2	
		jsr	   CLOSE
		inc	   sp
		pop	   d0		;Fehlercode restaurieren
		ror	sf -,-,-	;N-Flag setzen
		jmp	   .ende	

;-----------------------------------------------------------------------------
;PREPARE_SEARCH 
;-----------------------------------------------------------------------------
;Datei mu geffnet sein
;Es wird auf Anfang der Datei positioniert
prepare_search:	add	   -,sp,d0
		push	   d2
		push	   d3
		move	   (d0),d3	;d3:Zeiger auf Quelltring, ungepackt
		inc	   d0
		move	   (d0),d2	;d2:Ergebnispuffer, 8 Worte gro
		inc	   d0
		move	   (d0),d0	;d0: FDB-Adresse

;Ist FDB-Adresse gltig?
		jsr	   FDB_ADRESS
		jmi	   .ende

;Dateizeiger auf Dateianfang positionieren.
		add	   #6,d0	;Dateizeiger auf 0 positionieren
		clr	   (d0)
		inc	   d0
		clr	   (d0)

		move	   d2,d0	;Arbeitspuffer lschen
		move	   #8,d1
.clr:		clr	   (d0)		
		inc	   d0
		dec	sf d1
		jne	   .clr

;Namen uaf zulssige Zeichen untersuchen und kompremieren
		move	   #16,d0	;Maximal 16 Zeichen erlaubt
		clr	   d1		;Hi-Lo-Flag auf High
.copyloop:	cmp	   (d3),-	;Quellstring zu Ende? 
		jeq	   .fertig	;Ja, Aktion erfolgreich
		cmp	   #$2f,(d3)	;Ein / ist auch eine Endekennung
		jeq	   .fertig
		cmp        #$2a,(d3)	;* Rest des Namens ohne Bedeutung
		jeq	   .fill		
		cmp        #$3c,(d3)	;<
		jeq        .fehler
		cmp        #$3b,(d3)	;; (Semikolon)
		jeq        .fehler
		cmp        #$3e,(d3)	;>
		jeq        .fehler
		cmp        #$21,(d3)	;Begin zulssiger Bereich
		jmi        .fehler
		cmp        #$80,(d3)	;Ende zulssiger Bereich
		jpl        .fehler

		cmp	   d1,-		;Zeichen gltig -> kopieren
		bswp eq	   -,(d3),(d2)	;Zeichen ins Hibyte kopieren
		or   ne	   (d3),(d2)	;Bzw. ins Lowbyte...
		inc  ne	   d2		;...und Zielpointer erhhen
		inc	   d3		;Quellpointer weiterschalten
		eor	   -,d1		;Hi-Lo-Flag togglen
		dec	sf d0		;Maximal 16 Zeichen kopieren
		jne	   .copyloop
		cmp	   (d3),-
		jeq	   .fertig
		jmp	   .fehler	;Suchstring hat mehr als 16 Zeichen


;* wird in ????... expandiert
.fill:		cmp	   d1,-		;Zeichen gltig -> kopieren
		bswp eq	   -,#$3f,(d2)	;Zeichen ins Hibyte kopieren
		or   ne	   #$3f,(d2)	;Bzw. ins Lowbyte...
		inc  ne	   d2		;...und Zielpointer erhhen
		inc	   d3		;Quellpointer weiterschalten
		eor	   -,d1		;Hi-Lo-Flag togglen
		dec	sf d0
		jne	   .fill

.fertig:	cmp	   d0,#16	;Wenn Dateinamenlnge=0: Fehler
		jne	   .ende
.fehler:        move	   #104,d0	;Dateiname hat falsches Format
		ror	sf -,-,-	;N-Flag setzen
.ende:		pop	   d3
		pop	   d2
		rts			

;-----------------------------------------------------------------------------
;SCAN
;-----------------------------------------------------------------------------
;Packt einen Teilpfad (Zeichen zwischen 2 /'s) zusammen in einen Zielbereich
;Arbeitet wird PREPAR_SEARCH, Wildcards sind nicht zulssig, Dateizeiger
;wird nicht positioniert.
scan:		add	   -,sp,d0
		push	   d2
		push	   d3
		move	   (d0),d3	;d3:Zeiger auf Quelltring, ungepackt
		inc	   d0
		move	   (d0),d2	;d2:Ergebnispuffer, 8 Worte gro

		move	   d2,d0	;Arbeitspuffer lschen
		move	   #8,d1
.clr:		clr	   (d0)		
		inc	   d0
		dec	sf d1
		jne	   .clr

;Namen uaf zulssige Zeichen untersuchen und kompremieren, keine Wildcards
		move	   #16,d0	;Maximal 16 Zeichen erlaubt
		clr	   d1		;Hi-Lo-Flag auf High
.copyloop:	cmp	   (d3),-	;Quellstring zu Ende? 
		jeq	   .fertig	;Ja, Aktion erfolgreich
		cmp	   #$2f,(d3)	;Ein / ist auch eine Endekennung
		jeq	   .fertig
		cmp        #$3f,(d3)	;? nicht erlaubt
		jeq	   .fehler		
		cmp        #$2a,(d3)	;ebenso *
		jeq	   .fehler		
		cmp        #$3c,(d3)	;<
		jeq        .fehler
		cmp        #$3b,(d3)	;; (Semikolon)
		jeq        .fehler
		cmp        #$3e,(d3)	;>
		jeq        .fehler
		cmp        #$21,(d3)	;Begin zulssiger Bereich
		jmi        .fehler
		cmp        #$80,(d3)	;Ende zulssiger Bereich
		jpl        .fehler

		cmp	   d1,-		;Zeichen gltig -> kopieren
		bswp eq	   -,(d3),(d2)	;Zeichen ins Hibyte kopieren
		or   ne	   (d3),(d2)	;Bzw. ins Lowbyte...
		inc  ne	   d2		;...und Zielpointer erhhen
		inc	   d3		;Quellpointer weiterschalten
		eor	   -,d1		;Hi-Lo-Flag togglen
		dec	sf d0		;Maximal 16 Zeichen kopieren
		jne	   .copyloop
		cmp	   (d3),-
		jeq	   .fertig
		cmp	   (d3),#$2f
		jeq	   .fertig

.fehler:        move	   #104,d0	;Dateiname hat falsches Format
		ror	sf -,-,-	;N-Flag setzen
		pop	   d3
		pop	   d2
		rts			

.fertig:	cmp	   d0,#16	;Wenn Dateinamenlnge=0: Fehler
		jeq	   .fehler
		move 	   d3,d0	;Neuen Quellzeiger zurckgeben
		pop	   d3
		pop	   d2
		rts			

;-----------------------------------------------------------------------------
;SEARCH_NEXT
;-----------------------------------------------------------------------------
;Nchsten passenden Eintrag suchen
search_next: 	add        -,sp,d0
		pushall
		move	   (d0),d7	;d7: FDB-Adresse der Dir
		inc	   d0
		move	   (d0),d6	;d6: Zeiger auf Suchstring

;Ist FDB-Adresse gltig?
		move	   d7,d0
		jsr	   FDB_ADRESS
		jmi	   .ende

;Arbeitsspeicher zum Einlesen eines Directoryeintrages
		push	   #16
		jsr	   MALLOC	;Arbeitsspeicher anfordern
		inc	   sp
		jmi	   .ende
		move	   d0,d5	;d5: Zeiger auf Arbeitsbereich

;Einen Directoryeintrag einlesen
.read:		push       #16		;Anzahl
		push       d5		;Pufferzeiger
		push       d7		;FDB-Adresse
		jsr        READ		;liest entsprechend des Dateizeigers 16 Worte
		add        #3,sp
		jmi        .memfree	;Fehler aufgetreten!

		add	   #8,d5,d2	;d2:Zeiger auf eingelesenen Dateinamen
		cmp	   (d2),-	;Eintrag gltig
		jeq	   .read	;Nein
		move       d6,d4	;Adresse des Dateinamens nach d4
		move       #8,d3	;8*2 Zeichen vergleichen

;Entspricht der Name dem Suchkriterium?
.vergleich:     bswp	   (d4),-,d0	;hherwertiges Zeichen vergleichen
		cmp	   d0,#$3f
		jeq	   .lo
		bswp	   (d2),-,d1
		cmp        d0,d1	;Zeichen vergleichen
		jne        .read	;ungleich, nchsten eintrag berprfen
.lo:		and	   #$ff,(d4),d0	;niederwertiges Zeichen vergleichen
		cmp	   d0,#$3f
		jeq	   .ok	
		and	   #$ff,(d2),d1	
		cmp        d0,d1	;Zeichen vergleichen
		jne        .read	;ungleich, nchsten eintrag berprfen
.ok:		inc        d2		;gleich,...
		inc        d4		;...nchstes Zeichen vorbereiten
		dec     sf d3		;Zeichenzhler dec
		jne        .vergleich

;Eintrag ist passend, -> Positionieren auf Anfang des Directoryeintrages 
		add	   #7,d7	;Filepos auf Entryanfang zurcksetzen
		sub	sf #16,(d7)
		move mi	   #240,(d7)	;Dateizeiger low korrigieren, Bereich [0..255]
		dec	   d7
		dec mi	   (d7)
		clr	sf ~-		;Flags lschen

.memfree:	pushf
		move	   d0,d2	;Fehlercode retten
		push	   d5
		jsr	   mfree
		inc	   sp
		move	   d2,d0	;Fehlercode restaurieren
		popf

.ende:		popall
	        rts           

