;-----------------------------------------------------------------------------
;BLOCK BELEGUNG UND FREIGABE
;-----------------------------------------------------------------------------
;SEKTOR ANFORDERN 
;Fordert einen neuen Sektor zum Schreiben an.
;Die Sektoren werden nicht initialisisert, sondern 
;einfach zugewiesen und in den Verwaltungsektoren eingetragen.
;Verwaltungssektoren werden initialisiert. 
;Maximale Dateilnge: 65536 Sektoren * 512 Bytes = 32 MByte

sektor_fordern:	add	   -,sp,d0	;FDB-Adresse holen
		pushall
		move	   (d0),d7	;d7: FDB-Adresse
		add	   #2,d7,d5	;Treiberadresse holen
		move	   (d5),d5	;d5: Treiberadresse
		add	   #18,d7,d4	;d4: Pufferadresse

		add	   #6,d7,d0	;Wird der allererste Sektor der Datei angefortert?
		move	   (d0),d0
		cmp	   d0,-	
		jeq	   .erster	;Ja, schnelle Spezialbehandlung

		add	sf -,d0,-	;Den $ffff-ten Sektor nicht mehr holen
		move eq	   #108,d0	;Sonst: Maximale Dateilnge erreicht
		jeq	   .errorend

		add	   #14,d7,d1		;d1: Aktuelle Schachtelungstiefe
		add	   #.exp128,(d1),d1
		move	   (d1),d1
		cmp	   d0,d1		;Erhht sich die Schachtelungstiefe?
		jne	   .samelevel		;Nein

		jsr	   BLOCK_ALLOCATE			
		jmi	   .end

;Neuen Sektor initialisieren
		move	   d0,d2
		move	   d1,d3		
		add	   #10,d7,d0
		push	   #2		;2 Worte
		pushz			;Ab Wortpos		
		push	   d3		;Sektor low
		push	   d2		;Sektor high
		push	   d0		;Pufferadresse
		push	   #2		;Job 2: Schreiben
		driver	   d5
		add	   #6,sp
		jmi	   .end

;Neuen Sektor als Primrsektor eintragen
		add	   #10,d7,d0
		move	   d2,(d0)	;Neuer Sektor wird Primrsektor
		inc	   d0
		move	   d3,(d0)
		add	   #3,d0
		inc	   (d0)		;Schachtelungstiefe++

.samelevel:	add	   #10,d7,d1	;Nummer des Primrsektors holen
		move	   (d1),d0
		inc	   d1
		move	   (d1),d1
		add	   #6,d7,d3	;Relative Sektornummer der neuen Filepos holen
		move	   (d3),d3
		add	   #14,d7,d2	;d2: Schachtelungstiefe
		cmp	   #2,(d2)	;Wie oft mu dereferenziert werden?
		jmi	   .tiefe1
		jeq	   .tiefe2

.tiefe3:	rol	   d3,-,d2
		rol	   d2,-,d2
		and	   #3,d2	;d4=(d3 div 16384) and 3;
		jsr	   .deref

.tiefe2:	asl	   d3,-,d2
		bswp	   d2,-,d2
		and	   #127,d2	;d2=(d3 div 128) and 127;
		jsr	   .deref

.tiefe1:	and	   #127,d3,d2	;d2=d3 and 127;
		jsr	   .deref
		clr	sf ~-
		jmp	   .end

.errorend:	ror	sf -,-,-	;N-Flag setzen
.end:		popall
		rts

.erster:	jsr	   BLOCK_ALLOCATE  ;Neuen Sektor holen
		jmi	   .end
		add	   #10,d7,d2
		move	   d0,(d2)	;Neuer Sektor wird Primrsektor
		inc	   d2
		move	   d1,(d2)
		jmp	   .end

;Einmal derefferenzieren
.deref:		asl	   d2,-,d2	;d2=d2*2;
		push       #2           ;2 Worte lesen
		push       d2           ;Ab Position d2
		push       d1           ;Sektornummer lo
		push       d0           ;Sektornummer hi
		push       d4		;Pufferadresse
		push       -		;Job 1:lesen
		driver     d5           ;Treiberaufruf
		add        #2,sp
		pop	   d0		;Alte Sektornummer wieder holen
		pop	   d1
		add        #2,sp
		inc mi	   sp
		jmi	   .end
		
		cmp	   (d4),-	;Neuer Verweis=0?
		jne	   .nextref	;Nein, dereferenzieren
		inc	   d4
		cmp	   (d4),-
		dec	   d4
		jne	   .nextref	;Nein, dereferenzieren

;Falls beim Derefferenzieren ein Verweis 0 auftritt mu eine weiterer
;Sektor allokiert werden 
		push	   d0		;Wir haben einen 0-Verweis gefunden
		push	   d1		;--> Neuen Block holen
		jsr	   BLOCK_ALLOCATE 
		move	   d0,(d4)
		inc	   d4
		move	   d1,(d4)
		dec	   d4
		add mi	   #3,sp
		jmi	   .end
		pop	   d1
		pop	   d0

;Neuen Sektor eintragen
		push       #2           ;2 Worte schreiben
		push       d2           ;Ab Position d2
		push       d1           ;Sektornummer lo
		push       d0           ;Sektornummer hi
		push       d4		;Pufferadresse
		push       #2		;Job 2:Schreiben
		driver     d5           ;Treiberaufruf
		add	   #6,sp
		inc mi	   sp
		jmi	   .end

;Verweis war nicht 0: holen
.nextref:	move ne	   (d4),d0	;d0: Sektornummer, high
		add	   -,d4,d1
		move	   (d1),d1	;d1: Sektornummer, low
		rts

;Anzahl der logischen Sektoren pro Schachtelungstiefe
.exp128:	dw	   1,128,16384,$ffff
		
;-----------------------------------------------------------------------------
;BLOCK ALLOKIEREN
;-----------------------------------------------------------------------------
;Sektoradresse wird ber dei Register d0,d1 bergeben. Alookierte Sektoren 
;werden mit Null initialisiert.
;Diese Routine wird nur von der Routine SEKTRO_FORDERN aufgerufen, deswegen
;arbeiten diese beiden Routinen auch zusammen. Folgende Register enthalten
;dann Arbeitswerte:
;d4: Pufferbereich im FDB
;d5: Treiberadresse

;d0: Sektornummer high
;d1: Sektornummer low
block_allocate:	irqoff					;Semaphor berprfen
		cmp	   allocate_in_use,-
		move eq	   akt_task,allocate_in_use
		irqon
		jeq	   .semok
;(Hier knnte ein Fairness-Flag gesetzt werden! Konkurrierendes Block-Allokieren
;ist jedoch sehr unwahrscheinlich, es sei denn mehere Tasks kopieren Dateien
;oder schreiben blockweise Daten.)
		jsr	   SWITCHTASK
		jmp	   block_allocate

.semok:		push	   d2
		push	   d3
		push	   d6

;lnge der BAM bestimmen
.retry:		push	   -		;Lnge der BAM nach d6 holen
		push	   #17		;(=Sektornummer des letzen BAM-Sektors)
		pushz
		pushz
		push	   d4		;Ziel ist erstmal FDB-Pufferwort		push	   -
		push	   -
		driver	   d5
		add	   #6,sp
		jmi	   .ende
		move	   (d4),d6

;Position des letzten freien Sektors in BAM bestimmen
		push	   #2		;Pointer auf nchsten freien Eintrag
		push	   #18		;in BAM holen
		pushz
		pushz
		push	   d4
		push	   -
		driver	   d5
		add	   #6,sp
		jmi	   .ende
		move	   (d4),d2	;d2/d3 zeigt darauf
		add	   -,d4,d3
		move	   (d3),d3
		
.loop:		push	   -		;BAM-Entry lesen
		push	   d3
		push	   d2
		pushz
		push	   d4
		push	   -
		driver	   d5
		add	   #6,sp
		jmi	   .ende

		add	sf -,(d4),-	;Gibt es einen freien Sektor?
		jne	   .found	;Ja

		inc	   d3		;Kein Glck: Nchstes Wort im BOM-Sektor
		bswp	sf d3,-,-	;Sektorgrenze berschritten?
		jeq	   .loop	;Nein, im aktuellen Sektor weitersuchen
		inc	   d2		;Nchster Sektor
		clr	   d3		;Dort mit dem 1. Wort anfangen
		cmp	   d2,d6	;War das der letze BOM-Sektor?
		jpl	   .loop	;Nein, weitersuchen
		move	   #112,d0	;Ja, Datentrger voll
		jmp	   .ende

.found:		clr	   d6		;Bitnummer der ersten 0 ermitteln
		move	   -,d1		;d1: Bitmaske
.bitloop:	and	sf (d4),d1,-	;Bit clear?
		asl	ne d1		;Nein, nchstes Bit untersuchen
		inc	ne d6
		jne	   .bitloop

;Sektor in BAM belegen
		or	   d1,(d4)	;Sektor belegen
		push	   -		;Neuen BAM-Entry schreiben
		push	   d3
		push	   d2
		pushz
		push	   d4
		push	   #2
		driver	   d5
		add	   #6,sp
		jmi	   .ende

		move	   d2,(d4)	;BAM-Entry-Adresse im Bootsektor merken
		add	   -,d4,d0
		move	   d3,(d0)
		push	   #2
		push	   #18
		pushz
		pushz
		push	   d4
		push	   #2
		driver	   d5
		add	   #6,sp
		jmi	   .ende

		asl	   d3		;absolute Sektornummer bestimmen
		asl	   d3
		asl	   d3
		asl	   d3
		add	   d6,d3	;d3=Bit+16*Wort
		dec	   d2
		ror	   d2,-,d0
		ror	   d0
		ror	   d0
		ror	   d0
		and	   #$f000,d0
		add	   d0,d3	;d3=Bit+16*Wort+(4096*Sektor)&$f000
		lsr	   d2
		lsr	   d2
		lsr	   d2
		lsr	   d2		;d2=Sektor/16

		move	   #248,d6
.clearloop:	push	   #8		;Neuen Sektor mit 0 fllen
		push	   d6
		push	   d3
		push	   d2
		push	   #.nullen
		push	   #2
		driver	   d5
		add	   #6,sp
		jmi	   .retry	;Sektorfehler -> neuen Sektor
		sub	sf #8,d6
		jpl	   .clearloop

		clr	sf ~-		;Flags lschen
		move	   d3,d1	;Rckgabewerte
		move	   d2,d0
.ende:		clr	   allocate_in_use
;(Fairness-Flag berprfung hier!)
		pop	   d6
		pop	   d3
		pop	   d2
		rts

.nullen:	dw 0,0,0,0,0,0,0,0

;-----------------------------------------------------------------------------
;BLOCK FREE
;-----------------------------------------------------------------------------
;Gibt eine Sektor wieder frei. Die Sektornummer mu ber den Stack bergeben werden.
block_free:     add        -,sp,d0     
		pushall			;Register retten
		move       (d0),d7	;d7: FDB-Adresse
		inc        d0
		move       (d0),d1	;d1: Sektornummer low
		inc        d0
		move       (d0),d2	;d2: Sektornummer high

		asl	   d2		;Sektornummer h *16
		asl	   d2
		asl	   d2
		asl	   d2
		bswp	   d1,-,d0	;d0=Sektornummer low/4096
		lsr	   d0
		lsr	   d0
		lsr	   d0
		lsr	   d0
		add	   d0,d2	;d2:Sektornummer low des BAM-Eintrages
		inc	   d2
		and	   #$0fff,d1
		and	   #15,d1,d0	;Bit Nummer des BAM-Eintrages
		lsr	   d1
		lsr	   d1
		lsr	   d1
		lsr	   d1		;Wortnummer des BAM-Eintrages

		move	   -,d3		;d1: Bitmaske
		inc	   d0
.bitloop:	dec	sf d0
		asl ne 	   d3		;Nein, nchstes Bit untersuchen
		jne	   .bitloop
		move	   d1,d5

		add	   #18,d7,d4	;Pufferadresse in FDB
		push	   -		;Anzahl der Worte
		push	   d1		;Ab welchen Wort
		push	   d2		;Sektornummer lo
		pushz			;Sektornummer hi
		push	   d4		;Pufferadresse
		push	   -		;Job 1:lesen
		add	   #2,d7,d0
		driver	   (d0)	
		add	   #6,sp
		jmi	   .ende

		sub        d3,#$ffff,d3
		and        d3,(d4)    
		push	   (d4)

		push	   -		;Anzahl der Worte
		push	   d5		;Ab welchen Wort
		push	   d2		;Sektornummer lo
		pushz			;Sektornummer hi
		add	   #4,sp,d0
		push	   d0		;Pufferadresse;Wort d2 wieder abspeichern
		push	   #2		;Job 2:schreiben
		add	   #2,d7,d0
		driver	   (d0)	
		add	   #7,sp
		jmi	   .ende

		clr     sf ~-		;Flags lschen
.ende:		popall
		rts



;-----------------------------------------------------------------------------
;LOG_ABS
;------------------------------------------------------------------------------
;Nur interner Aufruf.
;Umwandlung der logischen Sektornummer in die absolute(HI & LO)
;do, d1 enthalten die gesuchten Nummern
log_abs:        add        -,sp,d1
		push	   d2
		push	   d3
		push	   d4
		push	   d5
		move       (d1),d4      ;d4: FDB-Adresse

;Primrsektor bestimmen
		add	   #10,d4,d1
		move	   (d1),d0	;Primrsektor high
		inc	   d1
		move	sf (d1),d1	;Primrsektor low
		jne	   .noerror
		cmp	   d0,-
		jne	   .noerror

.errorend:	sub	   -,-,d0	;Es gibt gar keine Datensektoren
		sub	sf -,-,d1	;Vorsichtshalber -1 zurckgeben mit N-Flag
		jmp	   .ende

.noerror:	add	   #14,d4,d2	;d2: Schachtelungstiefe holen 
		move	sf (d2),d2	
		jeq	   .ende	;Falls sie 0 ist, dann ist der Primrsektor der gesuchte

		add	   #6,d4,d3	;Relative Sektornummer der akt Filepos holen
		move	   (d3),d3

		add	   #2,d4,d5
		move	   (d5),d5	;Driveradresse
		add	   #18,d4	;Pufferadresse

		cmp	   #2,d2	;Wie oft mu dereferenziert werden?
		jmi	   .tiefe1
		jeq	   .tiefe2

;entsprechend der Schachtelungstiefe dereffenrenzieren
.tiefe3:	rol	   d3,-,d2
		rol	   d2,-,d2
		and	   #3,d2	;d4=(d3 div 16384) and 3;
		jsr	   .deref

.tiefe2:	asl	   d3,-,d2
		bswp	   d2,-,d2
		and	   #127,d2	;d2=(d3 div 128) and 127;
		jsr	   .deref

.tiefe1:	and	   #127,d3,d2	;d2=d3 and 127;
		jsr	   .deref

		clr	sf ~-
.ende:		pop	   d5
		pop	   d4
		pop	   d3
		pop	   d2
		rts             

.deref:		asl	   d2,-,d2	;d2=d2*2;
		push       #2           ;2 Worte lesen
		push       d2           ;Ab Position d2
		push       d1           ;Sektornummer lo
		push       d0           ;Sektornummer hi
		push       d4		;Pufferadresse
		push       -		;Job 1:lesen
		driver     d5           ;Treiberaufruf
		add        #6,sp
		inc mi	   sp
		jmi	   .errorend
		move	   (d4),d0	;1 mal dereferenzieren
		add	   -,d4,d1
		move	   (d1),d1
		rts

;------------------------------------------------------------------------------
;FDB_CHECK_X
;-----------------------------------------------------------------------------
;berprft, ob eine Datei schon zum lesen/schreiben geffnet ist
fdb_check_x:    add        -,sp,d0
		push	   d2
		push	   d3
		push	   d4
		add        #5,(d0),d1	;Adresse des zu berprfenden FDB holen
		clr	   d0		;Flags erst mal lschen
		move	   #fdblist,d2	;Adresse des 1. FDB in FDB-List holen

.loop:		move	sf (d2),d2	;Nchsten FDB in Liste
		jeq	   .exit	;Fertig?
		move	   d1,d3
		add	   #5,d2,d4
		cmp	   (d3),(d4)	;Verweis-Wortnummer gleich?
		jne	   .loop
		dec	   d3
		dec	   d4
		cmp	   (d3),(d4)	;Verweis-Sektornummer-low gleich?
		jne	   .loop
		dec	   d3
		dec	   d4
		cmp	   (d3),(d4)	;Verweis-Sektornummer-high gleich?
		jne	   .loop
		dec	   d3
		dec	   d4
		cmp	   (d3),(d4)	;Driver-Adresse gleich?
		jne	   .loop
		dec	   d4		;Doppelten FDB gefunden
		move	   (d4),d0	

.exit:          pop	   d4
		pop	   d3
		pop	   d2
		rts

;-----------------------------------------------------------------------------
;FDB_ADRESS
;-----------------------------------------------------------------------------
;berprfung, ob Adresse ein Zeiger auf einen gltigen FDB ist
fdb_adress:	add	   #8,d0		;Magic1 korrekt?
		cmp	   #$1234,(d0)	
		jne	   .fehler		;Nein
		inc	   d0			;Magic2 korrekt?
		cmp	   #$5678,(d0)
		jne	   .fehler		;Nein
		sub	   #9,d0		;d0 restore
		clr	sf ~-
		rts
.fehler:	move	   #101,d0		;Fehler: Ungltiges Handle
		ror	sf -,-,-
		rts

;-----------------------------------------------------------------------------
;OPENED_FILES
;-----------------------------------------------------------------------------
;berprffung ob fr angegebenes SCSI-Device noch zum Schreiben geffnete Dateien existieren
;Dies ist nur ein interner Aufruf.
opened_files:	add	   -,sp,d0
		push	   d2		
		clr	   d2		;Anzahl mit Null initialisieren

;Aus Treibernamen Treiberadresse bestimmen
		push	   (d0)
		jsr	   SEARCHDRIVER
		inc	   sp
		jmi	   .ende
		
;FDB-Liste durchsuchen und berprfen ob es noch zum Schreiben geffnete Dateien gibt
		move	   #fdblist,d1	
.fdblist:	cmp	   (d1),-
		jeq	   .ende
		move	   (d1),d1
		add	   #2,d1
		cmp	   (d1),d0	;Richtiges Device?
		sub  	   #2,d1
		jne	   .fdblist
		inc	   d1
		and	sf #4,(d1),-	;Zum Schreiben geffnet?
		inc ne	   d2		;Anzahl++
		dec	   d1
		jmp	   .fdblist

.ende:		move	   d2,d0	;d0: Anzahl
		pop	   d2
		rts


