;=============================================================================
;PARALLELPORT
;=============================================================================
equ parallel_data,$7ff8
equ parallel_status,$7ff9

;Initialisieren des Parallelporttreibers
;-----------------------------------------------------------------------------
parallel:	out        #8,parallel_status	;Init auslsen
		push	   #.driver
		jsr	   NEWDRIVER		;Treiber anmelden
		inc	   sp
		out        #4,parallel_status	;Init lschen
		rts

;Parallelport-Treiber
;-----------------------------------------------------------------------------
.driver: 	dw	   "par",0		;Treibername "par"
		dw	   1			;ist ein Zeichentreiber
		add	   -,sp,d1
		move	   (d1),d0		;Jobnummer holen
		inc	   d1
		move	   (d1),d1		;Parameter holen

;Job 1 "Status lesen"
;.............................................................................
		dec	sf d0			   ;Job 1?
		jne	   .nojob1		   ;Nein
		and	   @parallel_status,#63,d0 ;Statusreg. lesen, 5 Bits 
		rts
		
;Job 2 "Zeichen ausgeben"
;.............................................................................
.nojob1:	dec	sf d0		;Job 2?
		jeq	   .charout	;Ja, Zeichen ausgeben

;Job 3 "String ausgeben"
;.............................................................................
.nojob2:	dec	sf d0		;Job 3?			
		rts  ne			;Nein
		move	   d1,d0	;Stringpointer
.loop:		move	sf (d0),d1	;Zeichen holen
		rts eq
		jsr	   .charout
		inc	   d0		;Pointer++
		jmp	   .loop

;Gibt das Zeichen in d1 auf dem Drucker aus
;.............................................................................
.charout:	and     sf @parallel_status,#1,- ;Drucker bereit?
		jeq	   .do_it		;Ja
		jsr	   SWITCHTASK		;Nein, warten
		jmp        .charout

.do_it:		out        d1,parallel_data	;Zeichen ausgeben
		out        #2,parallel_status	;Strobe setzen
		out        #2,parallel_status	;Strobe setzen
		out        #2,parallel_status	;Strobe setzen
		out        #2,parallel_status	;Strobe setzen
		out        -,parallel_status	;Strobe lschen
		rts
