;===========================================================================
;ROM-Disk
;===========================================================================
romdisk:	push	  #.driver		;Treiber anmelden
		jsr	  NEWDRIVER
		inc	  sp
		rts

;Driver
;-------------------------------------------------------------------------
.driver:	dw	   "rom",0	;Drivername "rom"
		dw	   0		;Blockdevice
		add	   -,sp,d0	;Jobnummer holen
		move	   (d0),d0
		
;.............................................................................
;Job 1:Lesen
		dec	sf d0			;Job 1?
		jne	   .nojob1		;Nein
		add	   #3,sp,d0		;Block High mu 0 sein
		move	sf (d0),-
		jne	   .notvalid
		inc	   d0		
		bswp	   -,(d0),d1		;Block Low *256 holen
		add	   #.romddata,d1	;d1 zeigt auf Romdiskdatenblock
		cmp	   #.romddataend,d1
		jpl	   .notvalid		;Blocknummer war zu gro
		push	   d2
		inc	   d0
		and	   #255,(d0)		;1. Wort von 0..255 sicherstellen
		move	   (d0),d2		;d2 ist Nummer des 1. Wortes
		add	   d2,d1		;d1 zeigt auf 1. Wort
		inc	   d0
		add	   (d0),d2		;d2 ist Nummer des (letzten+1) Wortes
		cmp	   d2,#256		;Sicherstellen, da Block nicht verlassen wird
		move mi	   #256,d2
		dec	   d0
		sub	   (d0),d2		;In d2:Anzahl der Worte
		sub	   #3,d0
		move	   (d0),d0		;d0 zeigt auf Userpuffer
.copyloop:	dec	sf d2			;Weitere Worte kopieren
		jmi	   .exit		;Nein
		move	   (d1),(d0)		;1 Wort kopieren
		inc	   d1
		inc	   d0
		jmp	   .copyloop
.exit:		clr	sf ~-			;Flags lschen
		pop	   d2
		rts

.notvalid:	move	   #$0521,d0		;Block not Valid
		ror	sf -,-,-		;N-Flag
		rts

;.............................................................................
;Job 2:Schreiben
.nojob1:	dec	sf d0			;Job 2?
		jne	   .nojob2		;Nein
.wrtprot:	move	   #$0727,d0		;Doch, aber ROM-Disk ist schreibgeschtzt
		ror	sf -,-,-
		rts

;.............................................................................
;Job 3:Kapazitt ermitteln
.nojob2:	dec	sf d0			;Job 3?
		jne	   .nojob3		;Nein
		add	   #2,sp,d0
		move	   (d0),d0		;Userpufferadresse holen
		clr	   (d0)			;Letzte Sektor# high
		sub	   #.romddata,#.romddataend,d1 ;d1:Anzahl der Worte
		bswp	   d1,-,d1		;Anzahl der Blcke
		inc	   d0
		sub	   -,d1,(d0)		;Letzte Sektor# low
		inc	   d0
		clr	   (d0)			;Sektorgre high
		inc	   d0
		move	   #512,(d0)		;und low
		clr	sf ~-			;Flags lschen
		rts

;.............................................................................
;Job 4:Format
.nojob3:	dec	sf d0			;Job 4?
		jeq	   .wrtprot		;Ja, Disk ist aber schreibgeschtzt
		clr	sf ~-			;Alle anderen Jobs ok
		rts

;.............................................................................
.romddata:
bload romddata.obj
.romddataend:
