;-----------------------------------------------------------------------------
;SHELL
;-----------------------------------------------------------------------------
shell:		push       #258		;2*128 Zeichen Arbeitspuffer +2 gerettete Handlenummern
		jsr        MALLOC
		inc        sp
		move       d0,d7        ;d7:Zeiger auf Arbeitspuffer!
		jpl	   .memok

		push	   d0
		jsr	   FEHLER	;Kein Speicherplatz verfgbar!
		inc	   sp
		move	   #103,d0	
		ror	sf -,-,-
		rts

;Speicher konnte allokiert werden
;.............................................................................
.memok:		pushz			;Einschaltmeldung ausgeben
		push	   #initstring
		pushz
		jsr	   WRITE
		add	   #3,sp

.new:           move       d7,d5	;Beide Arbeitspuffer & stdin/out-Umlenkhilfvariablen lschen
		move       #258,d3
		move	   -,d6		;Puffergelerrt Flag setzen
.clrbuf:	clr        (d5)		;Puffer leeren
		inc	   d5
		dec	sf d3
		jne	   .clrbuf

		move       #127,d3	;Zhlt die freien Zeichen im Arbeitspuffer 1
	        move       d7,d5	;d5: Zeiger im Eingabepuffer

.old_string:	push       -
		push	   #13		;CR ausgeben...
		pushz			;... an StandardOut
		jsr	   WRITE
		add	   #3,sp
		jmi	   .fehler

		pushz
		push	   #clr_z	;Zeile lschen...
		pushz			;... an StandardOut
		jsr	   WRITE
		add	   #3,sp
		jmi	   .fehler

		push	   #cwd		;CWD-String im ENV-Bereich suchen
		jsr	   search_env
		inc	   sp

		pushz			;String ausgeben...
		push	   d0		;...und zwar die Cwd...
		pushz			;... an StandardOut
		jsr	   WRITE
		add	   #3,sp
		jmi	   .fehler

		push	   -		;Prompt ausgeben...
		push	   #$3e
		pushz			;... an StandardOut
		jsr	   WRITE
		add	   #3,sp
		jmi	   .fehler

;Eingaben einlesen
;.............................................................................
.getloop:	push	   -		;Ein Zeichen
		dec	   sp		;Dummywert, wegen 1 Zeichen lesen
		pushz      		;von Stdin
		jsr        READ		;einlesen
		add        #3,sp,=
		jpl	   .keystroke	;Ja, Zeichen angekommen
		cmp	   d0,#105
		jeq	   .finish
		jsr	   SWITCHTASK	;Nein, warten
		jmp	   .getloop

.keystroke:	bswp	   d0,-,d2	;d2:Scancode
		and        #$ff,d0	;d0:ASCII-Code
		cmp	   d2,#23	;f3:alten inhalt der Eingabezeile anzeigen
		jne	   .nicht_f3

		cmp	   d6,-		;Wurde Puffer schon verndert?
		jne	   .getloop	;ja
		move	   d7,d5
		move	   #127,d3
.bufloop:	cmp	   (d5),-	;Ende des Strings?
		inc ne	   d5
		dec ne	   d3
		jne	   .bufloop

		pushz			;String ausgeben...
		push	   d7
		pushz			;... an StandardOut
		jsr	   WRITE
		add	   #3,sp
		jmi	   .fehler
		move	   -,d6
		jmp	   .getloop

.nicht_f3:	cmp	   d6,-		;Ist Puffer schon gelerrt?
		jne	   .f1

;Puffer leeren falls erste Taste nicht F3
		move       d7,d5	;Beide Arbeitspuffer & stdin/out-Umlenkhilfvariablen lschen
		move       #258,d3
		move	   -,d6		;Puffergelerrt Flag setzen
.clrbuf2:      	clr        (d5)
		inc	   d5
		dec	sf d3
		jne	   .clrbuf2
		move       #127,d3	;Zhlt die freien Zeichen im Arbeitspuffer 1
	        move       d7,d5	;d5: Zeiger im Eingabepuffer

.f1:		cmp	   d2,#7	;f1:Eingabezeile lschen
		jeq	   .new
		cmp        d0,#13       ;Ende der Eingabe?
		jeq        .auswertung
		cmp        d0,#8        ;Backspace?
		jeq        .backspace
		cmp	   d2,#97	;Crs left?
		jeq	   .left
		cmp	   d2,#106
		jeq	   .right	;Crs right?
		cmp	   d2,#100
		jeq	   .delete	;Delete?
		cmp        #$20,d0
		jmi        .getloop     ;Zeichencode ohne Interesse!
		cmp        d0,#$7f
		jmi        .getloop     ;Zeichencode ohne Interesse!

		cmp	   d3,-		;Eingabepuffer voll?
		jeq	   .getloop	;Ja

		add	   #126,d7,d1	;1 Zeichen einfgen
		add	   -,d1,d2
.insert:	move	   (d1),(d2)
		dec	   d2
		cmp	   d1,d5
		dec	   d1
		jne	   .insert

		dec        d3		;Eingabepuffer um 1 verkleinern
		move       d0,(d5)	;Zeichen in Eingabepuffer schreiben
		inc        d5
		push	   -		;Das Zeichen an StdOut
		push	   d0
		pushz
		jsr	   write
		add	   #3,sp

.cmdlineout:	pushz
		push	   #crs_mark	;Cursorposition  merken
		pushz
		jsr        WRITE

		pushz			;String ab Cursorpos an Stdout ausgeben
		push       d5
		pushz
		jsr        WRITE

		pushz			;Zeile bis Ende lschen
		push	   #clr_z
		pushz
		jsr        WRITE

		pushz
		push	   #crs_set	;Cursor auf alte Position zurcksetzen
		pushz
		jsr        WRITE
		add        #12,sp
		jmi	   .fehler
		jmp	   .getloop	;Nchstes Zeichen

;Spezialtasten
;.............................................................................
.backspace:     cmp	   d5,d7	;Cursor schon ganz links?
		jeq	   .getloop	;Ja, kein Backspace mglich
		
		pushz
		push	   #crs_l	;Cursor 1 mal links
		pushz
		jsr        write
		add        #3,sp
		dec	   d5		;Eingabepos eins nach links

.delete:	cmp	   (d5),-	;Cursor ganz rechts?
		jeq	   .getloop	;Ja, nichts deleten
	
		inc	   d3		;Eingabezeile wird 1 kleiner
		add	   -,d5,d1	
		move	   d5,d0
.back:		move	sf (d1),(d0)	;Rest des Eingabestrings verschieben
		inc	   d0
		inc	   d1
		jne	   .back
		jmp	   .cmdlineout	;Kommandostring neu ausgeben

.left:	     	cmp	   d5,d7	;Cursor schon ganz links?
		jeq	   .getloop	;Ja

		pushz
		push	   #crs_l
		pushz
		jsr        WRITE	;Cursor verschieben
		add        #3,sp
		dec	   d5		;Eingabepos eins nach links
		jmp	   .getloop

.right:		cmp	   (d5),-	;Schon ganz rechts?
		jeq	   .getloop	;Ja

		pushz
		push	   #crs_r
		pushz
		jsr        WRITE	;Cursor verschieben
		add        #3,sp,=
		inc	   d5		;Eingabepos eins nach rechts
		jmp	   .getloop

.entry:		clr	   d6
		jmp	   .old_string


;User hat Return gedrckt
;.............................................................................
.auswertung:	pushz
		push	   #newline	;CR/LF ausgeben...
		pushz			;... an StandardOut
		jsr	   WRITE
		add	   #3,sp,=

;Parameter in Kommandozeile in Variable CMD= bertragen
		add	   #128,d7,d4	;Arbeitsbereich fr execute
		move	   d4,d0
		move	   #$63,(d0)	;c
		inc	   d0
		move	   #$6d,(d0)	;m
		inc	   d0
		move	   #$64,(d0)	;d
		inc	   d0
		move	   #$3d,(d0)	;=
		inc	   d0

		cmp	   (d7),-	;Eingabezeile leer?
		jeq	   .new
		move	   d7,d2	;d2: Anfang des Strings
		jsr	   SCANCMD	;Programmname berspringen

;Parameter suchen und in cmd eintragen
;.............................................................................
.scanloop:	cmp	   (d2),#$3c	;"<"?
		jeq	   .nextparam
		cmp	   (d2),#$3e	;">"?
		jeq	   .nextparam
.paramcopy:	move	sf (d2),(d0)	;1 Zeichen kopieren
		jeq	   .set_env	;Stringende-> Alle Parameter gefunden
		cmp	   #32,(d2)	;Parameter vollstndig kopiert?
		inc ne	   d2
		inc 	   d0
		jne	   .paramcopy
.nextparam:	jsr	   SCANCMD	;Pointer auf nchsten Parameter stellen
		jmp	   .scanloop

.set_env:	dec	   d0
		cmp	   #32,(d0)	;Wenn das letzte Zeichen ein Space war
		clr	eq (d0)		;Zeichen lschen
		push	   d4
		jsr	   SET_ENV	;Environment-Variable CMD setzen
		inc	   sp
		jmi	   .fehler

;Ein-/Ausgabeumlenkung bearbeiten
;.............................................................................
		move	   d7,d2	;d2: Anfang des Strings
		jmp	   .nextscan2

.scanloop2:	cmp	   #$3c,(d2)	;< Eingabeumlenkung
		jne	   .nur_out	;Nein, aber vielleicht Ausgabeumlenkung
		inc	   d2
		cmp	   #$3e,(d2)	;> Ausgabeumlenkung?
		jne	   .nur_in	;Auch nicht

;Ein-und Ausgabeumlenkung
		inc	   d2		;<> Behandlung
		add	   #256,d7,d3	;Hat schon eine Umlenkung stattgefunden?
		cmp	   (d3),-
		jne	   .nextscan2	;Ja, diese interessiert nicht mehr
		inc	   d3
		cmp	   (d3),-
		jne	   .nextscan2

		jsr	   SCANNAME	;Namen einlesen

		push	   #2		;Datei zum lesen & schreiben ffnen
		push	   d4
		jsr	   OPEN
		add	   #2,sp
		jmi	   .dateifehler

		add	   #20,akt_task,d1	;Stdin der akt. Task
		add	   #256,d7,d3
		move	   (d1),(d3)		;retten
		move 	   d0,(d1)		;Geffnete Datei wird neues Stdin
		inc	   d3			;Ebenso fr Stdout
		inc	   d1
		move	   (d1),(d3)
		move 	   d0,(d1)
		jmp	   .nextscan2

;Eingabeumlenkung
.nur_in:	add	   #256,d7,d3
		cmp	   (d3),-	;Hat schon eine Eingabeumlenkung stattgefunden?
		jne	   .nextscan2	;Ja, diese ignorieren
		
		jsr	   SCANNAME

		push	   -		;Datei zum lesen ffnen
		push	   d4
		jsr	   OPEN
		add	   #2,sp,=
		jmi	   .dateifehler

		add	   #20,akt_task,d1	;Stdin der akt. Task
		add	   #256,d7,d3
		move	   (d1),(d3)		;retten
		move 	   d0,(d1)		;Geffnete Datei wird neues Stdin
		jmp	   .nextscan2

;Ausgabeumlenkung
.nur_out:	cmp	   #$3e,(d2)	;> Ausgabeumlenkung ?
		jne	   .nextscan2	;Auch nicht
		inc	   d2

		add	   #257,d7,d3
		cmp	   (d3),-	;Hat schon eine Ausgabeumlenkung stattgefunden?
		jne	   .nextscan2

		jsr	   SCANNAME
	
		push	   #4		;Datei zum anhngen ffnen
		push	   d4
		jsr	   OPEN
		add	   #2,sp
		jmi	   .dateifehler

		add	   #21,akt_task,d1	;Stdout der akt. Task
		add	   #257,d7,d3
		move	   (d1),(d3)		;retten
		move 	   d0,(d1)		;Geffnete Datei wird neues Stdout

.nextscan2:	jsr	   scancmd		;Nchsten Parameter
		cmp	   (d2),-
		jne	   .scanloop2

;Programm laden
;.............................................................................
.loadprg:	move	   d7,d2
		cmp	   (d2),#38	;"&"-Vergleich: Taskstart erwnscht?
		move ne    -,d5		;d5 Flag, ob Unterprogramm oder Task
		clr  eq	   d5
		inc  eq    d2

		jsr	   SCANNAME

		push	   d4
		jsr	   PRG_LOAD
		inc	   sp
		jpl	   .startprg

;Pfad benutzen
		push       #path	;Dateiname war nicht in der Cwd,...
		jsr        SEARCH_ENV	;...deshalb Path benutzen
		inc        sp
		move mi    #100,d0	;Falls kein Pfad existiert: Datei nicht gefunden
		jmi        .fehler
		move       d0,d3	;d3: Pointer auf Pfad

.pfadloop:	cmp	   (d3),-	;Pfad zuende?
		move eq    #100,d0	;Ja, Datei nicht gefunden
		jeq        .fehler
		move	   #127,d6	;Zhler fr Zeichenanzahl max. 128
		move	   d4,d1	;Pufferzeiger

.copypfad:	cmp	   (d3),-	;Pfadende?
		jeq        .pfadok	;Fertig bei Stringende
		cmp        #$3b,(d3)    ;Ende des Teilpfades (;)?
		inc  eq	   d3
		jeq        .pfadok	;Fertig bei Stringende
		move 	   (d3),(d1) 	;1 Zeichen kopieren
		inc  	   d3
		inc	   d1   
		dec 	sf d6
		jpl	   .copypfad
		move	   #107,d0
		jmp	   .fehler

.pfadok:	move	   d2,d0	;Programmnamen mit Pfad verbinden
.space5:	cmp	   (d0),-	;Stingende?
		jeq	   .trytoload	;Ja, gleich Programm ausfhren
		cmp        (d0),#$20    ;Ende des Dateinamens suchen        
		jeq	   .trytoload	;Ja, gleich Programm ausfhren
		move 	   (d0),(d1)
		inc	   d1
		inc 	   d0
		dec     sf d6
		jpl        .space5
		move	   #107,d0
		jmp	   .fehler

.trytoload:	clr	   (d1)		;0 Eintragen als Endekennung fr open		

		push	   d4
		jsr	   PRG_LOAD
		inc	   sp
		jmi	   .pfadloop

;Das Programm wird nun gestartet
;.............................................................................
.startprg:	move	   d0,d6	;d6:Speicherblock des Programms

		push	   d7
		push	   d6
		cmp        d5,-		;Task oder Subroutine?
		jeq	   .task
		sub	   #2,d6,d0	;
		move	   sp,d1	;Eigenen Stackppointerretten
		sub	   #2,(d0),d0
		add	   d0,d6,sp	;Neuen Stackpointerbenutzen
		push	   d1		;aktuellen Stackpointer retten auf Subroutinen Stack
		push	   #.return	;Subroutine
		add	   d6,-,=       ;jsr Programm

;Programm als neue Task starten
;.............................................................................
.task:		add	   #21,akt_task,d1
		add	   #257,d7,d0
		cmp	   (d0),-	;Wurde Ausgabe umgelenkt?
		push ne	   (d1)		;Ja, vererben...
		move ne	   (d0),(d1)	;...und wieder das alte Stdout benutzen
		pushz eq		;Nein, das Programm macht keine Ausgaben
		dec	   d1
		dec	   d0
		cmp	   (d0),-	;Wurde eine Eingabeumlenkung vorgenommen?
		push ne	   (d1)		;Ja, neues Stdin vererben...
		move ne	   (d0),(d1)	;...und wieder das alte Stdin benutzen
		pushz eq		;Nein, keine Std-Eingabe
		push	   d4		;Taskname		
		push       d6		;Startadresse
		push	   #256		;Gre des Environmentbereiches
		jsr        STARTTASK	;Task starten
		add        #5,sp
		pop	   d6
		pop	   d7
		add pl	   #257,d7,d0
		clr pl     (d0)
		dec pl	   d0
		clr pl	   (d0)
		jpl        .entry
		jmp	   .restore

;Bei Fehler oder Ende: Alles rckgngig machen (Stdin/out/Memory)
;.............................................................................
.return:	inc	   sp
		move	   (sp),sp		;Stackpointer restaurieren
		pop	   d6
		pop	   d7
.restore:	push       d6
		jsr        MFREE     	;Programmspeicher wieder freigeben
		inc	   sp		;Einer mehr, wegen rts des Programms
		jsr	   .iorestore
		jmp	   .entry

.dateifehler:	push	   d0
		jsr	   .iorestore
		pushz
		push	   d4
		pushz
		jsr	   write
		add	   #3,sp
		pop	   d0

.fehler:	push	   d0
		jsr	   .iorestore
		jsr	   fehler
		inc	   sp
		jmp	   .entry

;StandardIn+Out-Wechsel rckgngig machen
.iorestore:	add	   #20,akt_task,d2 
		add	   #256,d7,d3
		cmp	   (d3),-
		jeq	   .rest_out
		push	   (d2)
		jsr	   CLOSE
		inc	   sp
		move 	   (d3),(d2)
		clr	   (d3)
.rest_out:	inc	   d2
		inc	   d3
		cmp	   (d3),-
		rts eq
		push	   (d2)
		jsr	   CLOSE
		inc	   sp
		move 	   (d3),(d2)
		clr	   (d3)
		rts

;Shell beenden
.finish:	pushz			;Endemeldung ausgeben
		push	   #bye
		pushz
		jsr	   write
		add	   #3,sp

		push	   d7
		jsr	   mfree
		inc	   sp

		rts

;Weiterschalten von d2 (Aktuelle Kommandlineposition)
;.............................................................................
scancmd:	cmp	   (d2),-	;Stringende?
		rts eq			;Ja, fertig mit scannen
		cmp        (d2),#$20    ;Nicht-Spaces berlesen
		inc ne     d2
		jne        scancmd

.space:		cmp        (d2),#$20  	;Spaces berlesen
		inc eq     d2
		jeq        .space
		rts

;Dateinamen fr IO-Umlenkung lesen
;.............................................................................
SCANNAME:	move	   d2,d3
		move	   d4,d0	;Pufferzeiger
.space:		cmp	   (d3),-	;Stingende?
		jeq	   .redir	;Ja, gleich Datei ffnen
		cmp        #$20,(d3)	;Ende des Dateinamens suchen        
		move ne	   (d3),(d0)
		inc  ne    d3		;Lesezeiegr weiterschalten
		inc  ne	   d0		;Pufferzeiger weiterschalten
		jne        .space

.redir:		clr 	   (d0)		;Stringende erzeugen
		rts



initstring:	dw 13,10,"XShell 1.0 bereit.",13,10,0
path:   	dw "path="
crs_l:		dw 27,"D",0
crs_r:		dw 27,"C",0
crs_mark:	dw 27,"j",0
crs_set:	dw 27,"k",0
clr_z:		dw 27,"K",0
newline:	dw 13,10,0
bye:		dw "Bye!",13,10,0
